/*
 * XaAES - XaAES Ain't the AES
 *
 * A multitasking AES replacement for MiNT
 *
 */

#include <osbind.h>
#include <falcon.h>
#include <mintbind.h>
#include <unistd.h>
#include <fcntl.h>
#include <ioctl.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <ostruct.h>

#include "xa_types.h"
#include "handler.h"
#include "kernal.h"
#include "c_window.h"
#include "xa_globl.h"
#include RSCHNAME
#include WIDGHNAME
#include "signals.h"
#include "rectlist.h"
#include "objects.h"
#include "f_xbios.h"
#include "kernal.h"
#include "widgets.h"
#include "menuwidg.h"
#include "desktop.h"
#include "xa_form.h"
#include "scrlobjc.h"
#include "xa_shel.h"
#include "xa_fsel.h"
#include "xa_rsrc.h"

bool in_kernel = false;

/* aes.h confilcts with k_defs.h, so we can't use it here... :-( */
#if defined(LATTICE)				/* ----- Lattice C ----- */
	extern short _AESglobal[15];
	#define global _AESglobal
	int __regargs _AESif(unsigned int);
	#define appl_init() _AESif(0x0a000100)
	extern int graf_handle(short *,short *,short *,short *);
	#define appl_exit()	_AESif(0x13000100)

#elif defined(__PUREC__)			/* ----- Pure C 1.1 ----- */

	typedef struct
	{
		int		contrl[15];
		int		global[15];
		int		intin[132];
		int		intout[140];
		void	*addrin[16];
		void	*addrout[16];
	} GEMPARBLK;
	extern  GEMPARBLK _GemParBlk;
	#define global _GemParBlk.global
	extern int appl_init(void);
	extern int graf_handle(int *, int *, int *, int *);
	extern int appl_exit(void);

#else						/* ----- others ----- */

	#if 0			/* Old GEMLIB */
		#define global _global
	#else			/* New GEMLIB */
		#define global aes_global
	#endif
	extern short global[] ;
	extern int appl_init(void) ;
	extern int graf_handle(int *, int *, int *, int *);
	extern int appl_exit(void);
#endif

/*
 *	Boot up code
 */
extern char **environ;			/* HR: ex startup.s */
char *environment;				/* HR: new environment */

short superprogdef = 0;		/* HR */
bool toscase = false;			/* HR */
const char select_ink[] = {27, 'b', 0};
const char select_paper[] = {27, 'c', 0};
static short auto_program;			/* HR: moved up */
short point_to_type = 0;
char *half_screen_buffer = nil;			/* HR: for wind_get WF_SCREEN (people like to use what is offered, whether the idee is good or not) */
size_t half_screen_size = 0;
short modecode = 0;
bool  havemode = false;
unsigned long mint=0,falcon=0;		/* cookies & cookie values */
char *strings[STRINGS];			/* HR: pointers to environment variables from mint & config file */
short envs = 0;					/*    no of pointers used */

/* external fileselector support (preliminary) */
bool fsel_cookie;
#if FILESELECTOR
bool no_xa_fsel = false;
#else
bool no_xa_fsel = true;
#endif

#if MYPRINTF
/* reduced (faster) version */
int vsprintf(char *to, const char *f, void *sp)
{
	char *s = to;

	do
	{
		char c=*f++,*fro;
		int i,sz;
		bool lo;
		unsigned long l;

		if (c eq '%')
		{
			c = *f++;

			sz = 0;				/* for x */
			if (c eq '0')
			{
				sz = *f++ - '0';
				c = *f++;
			}

			if ( (lo = c eq 'l') ne 0)
				c = *f++;

			switch (c)
			{
			case 's':
				fro = va_arg(sp,char *);
				while((*s++ = *fro++) ne 0);
				s--;
				break;

			case 'd':
				if (lo)
				{
					char x[16];
					long sign;
					l = va_arg(sp, long);
					if ( (sign=l) < 0 ) l=-l;
					fro=&x[sizeof(x)-1];
					*fro=0;
					do *--fro=l%10+'0'; while ((l/=10) > 0 );
					if ( sign<0 ) *--fro='-';
					while((*s++ = *fro++) ne 0);	
					s--;				
				othw
					char x[7];
					int sign;
					i = va_arg(sp, int);
					if ( (sign=i) < 0 ) i=-i;
					fro=&x[sizeof(x)-1];
					*fro=0;
					do *--fro=i%10+'0'; while ((i/=10) > 0 );
					if ( sign<0 ) *--fro='-';
					while((*s++ = *fro++) ne 0);	
					s--;				
				}
				break;

			case 'X':
			case 'x':
			{
				char x[9];
				if (lo)
					l = va_arg(sp,long);
				else
					l = va_arg(sp, int);
				for (i=0;i<sizeof(x);i++) x[i]='0';
				fro=&x[sizeof(x)-1];
				*fro--=0;
				do
				{
					i=(l%16);
					*fro--=i+(i<10?'0':'W');
				} while ((l/=16) > 0 );
				fro=x;
				if (!sz)
				{
					while (*fro == '0') fro++;
					if (*fro == 0)
						fro--;
				}
				else
					fro += sizeof(x) -1 - sz;	/* preliminary */
				while((*s++ = *fro++) ne 0);
				s--;
			}
			break;
			case 'c':
				*s++=va_arg(sp,int);
				break;

			default:
				*s++=c;
			}
		othw
			*s++=c;
		}
	} while (*f);
	*s = 0;
	return s - to;
}

int sprintf(char *to, const char *t, ...)
{
	int l;
	va_list argpoint;
	va_start(argpoint,text);
	l = vsprintf(to,t,argpoint);
	va_end(argpoint);
	return l;
}
#endif

/* HR: absolutely NO need for stream io */

int printf(const char *t, ...)	/* avoid use of stream IO */
{
	int l;
	char line[512];
	va_list argpoint;
	va_start(argpoint,text);
	l = vsprintf(line,t,argpoint);
	if (line[l-1] == '\n')
		if (line[l-2] != '\r')
		{
			l++;
			line[l-2] = '\r';
			line[l-1] = '\n';
			line[l  ] = 0;
		}
	va_end(argpoint);
	Cconws(line);
	return l;
}

void BootMessage(unsigned long mint)
{
	if (mint)
	{
		printf("It's FreeMiNT v%ld.%ld.%ld%c%c \n",
				 mint>>24,
				(mint>>16)&255,
				(mint>> 8)&255,
				(mint&255) ? ' .' : '  ',
				(mint&255) ? (short)mint&255 : (short)'  '
				);
		printf(" and ");
	}
	printf("XaAES " XA_VERSION "\n");
	printf("MultiTasking AES for MiNT\n");
	printf("(w)1995,96,97,98,99 Craig Graham, Johan Klockars, Martin Koehling, Thomas Binder\n");
	printf("     and other assorted dodgy characters from around the world...\n");
	printf("   1999,2000 Henk Robbers @ Amsterdam\n");
	printf("Date: %s, time: %s\n", __DATE__,__TIME__);
	printf("Compile time switches enabled:\n");

#if GENERATE_DIAGS
	printf(" - Diagnostics\n");
#endif

#if FORCE_WINDOWS
	printf(" - Force windows\n");
#endif

#if SOLID_BOXES
	printf(" - Solid boxes\n");
#endif

#if MONO_WIDGETS					/* HR: not used */
	printf(" - Mono widgets\n");
#else
	printf(" - Colour widgets\n");
#endif
		
#if DISPLAY_LOGO_IN_TITLE_BAR
	printf(" - Logo in title bar\n");
#endif

#if POINT_TO_TYPE
	printf(" - Point-to-type capability\n");
#endif

#if ALT_CTRL_APP_OPS
	printf(" - CTRL+ALT key-combo's\n");
#endif

#if USE_CALL_DIRECT
	printf(" - Use direct-call\n");
#endif

#if AVOID_MINT_PIPES_BUG
	printf(" - Avoid MiNT pipe delete bug\n");
#endif

#if DODGY_MEMORY_PROTECTION
	printf(" - Dodgy OS_SPECIAL memory access\n");
#endif

#if DEBUG_MALLOCS
	printf(" - Use cmalloc(m,1) instead of malloc(m)\n");
#endif

#if REALTIME_SCROLL
	printf(" - Realtime (live) window scrolling\n");
#endif

#if PRESERVE_DIALOG_BGD
	printf(" - Preserve dialog backgrounds\n");
#endif

#if ! FILESELECTOR
	printf(" - Built without file selector\n");
#endif
#if ! TEAR_OFF
	printf(" - Menu's can *not* be teared off\n");
#endif
	if (superprogdef)
		printf("progdefs are executed in supervisor mode\n");
	printf(" - Static Pid Array\n");
	if (fsel_cookie)
		printf(" - FSEL cookie found\n");
	if (falcon == 0x0030000L)
		printf(" - Falcon video handled\n");
	if (auto_program)
	{
		if (havemode)
			printf(" - video mode %d(x%x)\n",modecode,modecode);
		printf("auto program\n");
	}
	printf("\n");
#if GENERATE_DIAGS
	bios(2,2);
#endif
}

short P_handle = 0, V_handle = 0;			/* Workstation handles used by the AES */
XA_SCREEN display;					/* The display descriptor */
const XA_COLOUR_SCHEME default_colours = {LWHITE, BLACK, LBLACK, WHITE, BLACK, CYAN};
const XA_COLOUR_SCHEME bw_default_colours = {WHITE, BLACK, BLACK, WHITE, BLACK, WHITE};		/* HR: more white */
far long AES_in_pipe = 0;				/* The AES instruction input pipe handle */
unsigned long client_handle_mask = 0L;			/* Mask of all active client pipes for Fselect */

far long MOUSE_dev = 0L;				/* The /dev/mouse handle */
short double_click_time = DOUBLE_CLICK_TIME;		/* Double click timing */

MOOSE_VECS_COM vecs_com =				/* HR: Gets the VDI vector routine addresses from the moose. */
	{
		MOOSE_VECS_PREFIX,nil,nil,nil
	};
vdi_vec *svmotv = nil,
		*svbutv = nil,
		*svtimv = nil;

short font_id = STANDARD_AES_FONTID;			/* Font id to use */
short standard_font_point = STANDARD_FONT_POINT;	/* Size for normal text */
short medium_font_point = MEDIUM_FONT_POINT;		/* The same, but for low resolution screens */
short small_font_point = SMALL_FONT_POINT;		/* Size for small text */
MENU_BEHAVE menu_behave = PULL;			/* HR: pull, push or leave (leave implies pull) */
long KBD_device = 0;					/* The MiNT keyboard device's file handle */

long Salert_pipe;					/* The MiNT Salert() pipe's file handle */

short AESpid,						/* The AES's MiNT process ID */
	  DSKpid = -1;				/* HR The desktop programs pid, if any */
XA_CLIENT *Aes;					/* HR static pid array */

/*
XA_WINDOW *root_window;					/* The desktop window */
*/

Path XaAES_home,				/* XaAES's home location */
     scrap_path,				/* Path to the scrap directory */
     acc_path;					/* Path to desk accessory directory */

short XaAES_home_drv;

void *system_resources,					/* Pointer to the XaAES resources */
     *widget_resources;					/* HR: Pointer to the widget resource (icons) */
char *resource_name;					/* full name found */

short iconify_x, iconify_y, iconify_w, iconify_h;	/* Positioning information for iconifying windows */

#if 0		/* nor needed anymore since the menu is a standard widget */
#ifndef FIX_PC
const
#endif
XA_WIDGET_LOCATION sys_menu_loc = {LT, 0, 0};	/* HR */
#endif

#include "ipff.h"

char cancel_buttons[NUM_CB][CB_L];

/* HR: find a xaaes file. When the cd command to XaAES load directory is
       missing in mint.cnf (which is likely for inexperienced mint users. ;-) 
       XaAES wont fail completely. */
char *dirs[] =
{
	"",					/* plain name only */
	XaAES_home,			/* path (no drive!!) Dont forget to fill. */
	"c:" sbslash "mint" sbslash,
	"c:" sbslash "mint" sbslash "xaaes" sbslash,
	"c:" sbslash "gemsys" sbslash,
	"c:" sbslash "gemsys" sbslash "xaaes" sbslash,
	"c:" sbslash,
	"c:" sbslash "xaaes" sbslash,
	nil
},
	**aes_path;

/* HR */
static char moose_name[] = "u:" sbslash "dev" sbslash "moose";
char AES_cmd_name[] = "u:" sbslash "pipe" sbslash "XaAES.cmd";

/* The real shell_find isnt there yet. ;-) */
char *xa_find(char *fn)
{
	long fl;
	static char p[200];

	aes_path = dirs;
	while (*aes_path)
	{
		char *pad = *aes_path;
		sprintf(p,"%s%s", pad, fn);
		fl = Fopen(p,0);
		if (fl > 0)
		{
			Fclose(fl);
			if (isalpha(*pad) && *(pad + 1) == ':')
				strcpy(XaAES_home, pad);		/* whole new path */
			return p;
		}
		aes_path++;
	};
	return nil;
}

char *Fload(const char *name, int *fh, long *l)
{
	long pl,fl;
	char *bitmap=0L;

	*l  =0;
	fl  =*fh;		/* if already opened, *fh is handle */
	if (name)		/* if not already or want to open */
		fl = Fopen(name,0);
	if (fl >= 0)
	{
		fl&=0xffff;
		pl=Fseek(0L,fl,2);		/* seek end */
		Fseek(0L,fl,0);			/* seek start */
		bitmap=malloc(pl+1);
		if (bitmap)
		{
			Fread(fl,pl,bitmap);
			Fclose(fl);
			*l=pl;
			*(bitmap+pl)=0;		/* make it a C string */
		}
	}
	*fh=fl;
	return bitmap;
}

/*
 * Read & parse the 'xaaes.cnf' file.
 */
#if GENERATE_DIAGS
static
void debugp(debug_item *d)
{
	d->point = 1;
	if (sk() == '/')
	{
		skc();
		d->pid = idec();
	}
	else
		d->pid = 0;
}
#endif

char *config = nil;
bool have_run = false;

char ARGV[] = "ARGV=";

void before_run(void)
{
	void display_env(char **env, int which);
	long ct = 0;

	if (!have_run)
	{
		have_run = true;
	
		/* Count the number of bytes needed for the new environment,
		   that is: without any ARGV string. */
		ct = count_env(strings, ARGV);

		/* Allocate the new environment */
		environment = malloc(ct);

		/* Copy all the strings to the new environment, without any ARGV string. */
		if (environment)
			copy_env(environment, strings, ARGV);

#if GENERATE_DIAGS
		printf("Copy of envireonment\n");
		display_env(strings,2);
#endif
		environ = strings;		/* This is for some compatabilities */
	}
}

void parse_cnf(void)
{
	extern char Filters[23][16];
	extern char launch_path[];
	extern short debug_lines;
	char *cnf; short fh, t;
	char *translation_table, *lb, parms[200], *p;
	long tl, err = 0; int lnr = 0;

	for (t = 0; t < NUM_CB; t++)
		cancel_buttons[t][0] = 0;

/* HR: init scrap_path; */
	*scrap_path = 0;

	p = xa_find(CNFNAME);
	if (p)
		cnf = Fload(p,&fh,&tl);
	if (cnf eq nil)
		return;
	config = cnf;
	ipff_init(IPPF_L-1,PATH_MAX-1,0,nil,cnf,&translation_table);	/* initialize */

	/* translate everything to lower case */
	for (t = 'A'; t <= 'Z'; t++)
		translation_table[t] = t - 'A' + 'a';
	Filters[0][0] = 0;

/*	HR:
	 It is not obligatory to do line based parsing;
	ipff_line zeroizes \r & \n,
	\r & \n are otherwise treated as white space,
	alternative:
		replace lb by cnf,
		dont use ipff_line and loop around anyway you like.
		pe: while(is_keyword(rstr))	or something like that.
		Comment must be enclosed then I suppose. :-)
*/

	while((lb = ipff_line(&tl)) ne nil)
	{
		char rstr[IPPF_L];

		lnr++;

		if (tl eq 0)
			continue;

		if (lb[0] != '#')	/* '#' is a comment line */
		{
			if (sk() eq '#')	/* skip white space, return nonwhite character */
				continue;

			ipff_trail(lb);	/* remove trailing spaces */
#if GENERATE_DIAGS
			printf("%s\n", ipff_getp());
#endif
			str(rstr);		/* get a word */
			sk();			/* skip white space */

			if (*rstr == 0)
				err = printf("line %d: a line must start with a alphanumeric keyword\n", lnr);
			elif (strcmp(rstr,"run") eq 0)
			{
				short run;
				char p[210];

				before_run();
				fstr(p,0);
				sk();
				parms[0] = sprintf(parms+1,"%s",ipff_getp());
				launch(NOLOCKING, 0, 0, 0, p, parms, Aes);
			}
			elif (strcmp(rstr,"shell") eq 0 or strcmp(rstr,"desk") eq 0)
			{
				char p[210];

				before_run();
				fstr(p,0);
				sk();
				parms[0] = sprintf(parms+1,"%s",ipff_getp());
				DSKpid = launch(NOLOCKING, 0, 0, 0, p, parms, Aes);
			}
			elif (strcmp(rstr,"launcher") eq 0)
				fstr(launch_path,0);
			elif (strcmp(rstr,"clipboard") eq 0)
				fstr(scrap_path,0);
			elif (strcmp(rstr,"accpath") eq 0)
				fstr(acc_path,0);
			elif (strcmp(rstr,"dc_time") eq 0)
				double_click_time = idec();
#if GENERATE_DIAGS
			elif (strcmp(rstr,"debug_lines") eq 0)
				debug_lines = idec();
			elif (strcmp(rstr,"debug") eq 0)
			{
				if (isdigit(sk()))
					D.all.point = idec();
				else
				{
					char *p = ipff_getp();
					str(rstr);
					if (strcmp(rstr,"off") eq 0)
						D.all.point = 0;
					elif (strcmp(rstr,"on") eq 0)
						D.all.point = 1;		/* This means only the DIAGS macro's (the old ones) */
					elif (strcmp(rstr,"all") eq 0)
					{
						debugp(&D.all);
						D.all.point = 3;
					}
					elif (!debug_file)
					{
						ipff_putp(p);
						fstr(debug_path,0);
						if (strnicmp(debug_path, "screen", 6) != 0)
						{
							printf("\n\n\nDebug to %s\n", debug_path);
					
						#if 1		/* HR: Want to see session date / time */
							debug_file = (int)Fcreate(debug_path, 0);
						#else
							debug_file = (int)Fopen(debug_path, O_CREAT|O_WRONLY);
						#endif
							Fforce(1, debug_file);
						}
					}
				}
			}
			/* If specified together with debug all, the meaning is reversed. */
			elif (   strcmp(rstr,"debugpoint") eq 0
			      or strcmp(rstr,"except"    ) eq 0  /* only for readability together with 'all' */
			     )
			{
				if (!D.all.point) D.all.point = 2;
				do{
					str(rstr);
					if (strlen(rstr) eq 1 and isalpha(*rstr))
						debugp(((debug_item *)&D.a+(tolower(*rstr)-'a')));
					elif (strncmp(rstr,"appl", 4) eq 0 ) debugp(&D.appl );
					elif (strcmp(rstr,"evnt"    ) eq 0 ) debugp(&D.evnt );
					elif (strncmp(rstr,"mult", 4) eq 0 ) debugp(&D.multi);
					elif (strncmp(rstr,"form", 4) eq 0 ) debugp(&D.form );
					elif (strcmp(rstr,"fsel"    ) eq 0 ) debugp(&D.fsel );
					elif (strncmp(rstr,"graf", 4) eq 0 ) debugp(&D.graf );
					elif (strncmp(rstr,"menu", 4) eq 0 ) debugp(&D.menu );
					elif (strcmp(rstr,"objc"    ) eq 0 ) debugp(&D.objc );
					elif (strcmp(rstr,"rsrc"    ) eq 0 ) debugp(&D.rsrc );
					elif (strcmp(rstr,"scrp"    ) eq 0 ) debugp(&D.scrp );
					elif (strncmp(rstr,"shel", 4) eq 0 ) debugp(&D.shel );
					elif (strncmp(rstr,"wind", 4) eq 0 ) debugp(&D.wind );
					elif (strncmp(rstr,"widg", 4) eq 0 ) debugp(&D.widg );
					elif (strncmp(rstr,"mous", 4) eq 0 ) debugp(&D.mouse);
					elif (strncmp(rstr,"keyb", 4) eq 0 ) debugp(&D.keybd);
					elif (strncmp(rstr,"sema", 4) eq 0 ) debugp(&D.sema );
					elif (strncmp(rstr,"rect", 4) eq 0 ) debugp(&D.rect );
					elif (strncmp(rstr,"pipe", 4) eq 0 ) debugp(&D.pipe );
					elif (strncmp(rstr,"trap", 4) eq 0 ) debugp(&D.trap );
					if (sk() eq ',') skc();
					else break;
				}od
			}
#else
			elif (   strcmp(rstr,"debug") eq 0
			      or strcmp(rstr,"debugpoint") eq 0
			      or strcmp(rstr,"except"    ) eq 0
			      )
				;		/* Do nothing with this line */
#endif
#if USE_CALL_DIRECT
			elif (strcmp(rstr,"direct") eq 0)
			{
				str(rstr);
				if (strcmp(rstr,"on") eq 0)
				{
					short c;
					direct_call = 1;
					if (isdigit(c=sk()))
						direct_call = c - '0';
				}
				else
					direct_call = 0;
			}
#endif
			elif (strcmp(rstr,"font_id") eq 0)
				font_id = idec();
			elif (strcmp(rstr,"standard_point") eq 0)
				standard_font_point = idec();
			elif (strcmp(rstr,"medium_point") eq 0)
				medium_font_point = idec();
			elif (strcmp(rstr,"small_point") eq 0)
				small_font_point = idec();
			elif (strcmp(rstr,"menu") eq 0)
			{
				str(rstr);
				if (strcmp(rstr,"pull") eq 0)
					menu_behave = PULL;
				elif (strcmp(rstr,"push") eq 0)
					menu_behave = PUSH;
				elif (strcmp(rstr,"leave") eq 0)
					menu_behave = LEAVE;
			}
			elif (strcmp(rstr,"cancel") eq 0)
			{
				t = 0;
				do{
					str(rstr);
					if (strlen(rstr) >= NUM_CB)
						rstr[CB_L - 1] = 0;
					strcpy(cancel_buttons[t++],rstr);
					if (sk() eq ',' and t < NUM_CB - 1) skc();	/* last entry kept clear as a stopper */
					else break;
				}od
			}
			elif (strcmp(rstr,"toppage") eq 0)
			{
				str(rstr);
				if (strcmp(rstr,"bold") eq 0)
					topname = BOLD, backname = 0;
				elif (strcmp(rstr,"faint") eq 0)
					topname = 0,    backname = FAINT;
			}
			elif (strcmp(rstr,"superprogdef") eq 0)
				superprogdef = 1;
			elif (strcmp(rstr,"tosucase") eq 0)
				toscase = true;
			elif (   strcmp(rstr,"export") eq 0
			      || strcmp(rstr,"string") eq 0
			      || strcmp(rstr,"setenv") eq 0
			      )
			{
				if (have_run)
					err = printf("environment variable after any run or desk is discarded\n");
				else
				{
					char ide[IPPF_L];
					char *start = ipff_getp();
					str(ide);
					if (*ide)
					{
						char p[512];
						strupr(ide);
						strcpy(p,ide);
						strcat(p,"=");
						if (sk() == '=')
							skc();
						fstr(p + strlen(p),0);
						strcpy(start,p);
						strings[envs++] = start;
					}
				}
			}

#if POINT_TO_TYPE
			elif (strcmp(rstr,"focus") eq 0)
			{
				str(rstr);
				point_to_type = strcmp(rstr,"point") eq 0;
			}
#endif
#if FILESELECTOR && defined(FSEL_MENU)
			elif (strcmp(rstr,"filters") eq 0)
			{
				short i = 0;
				while (i < 23)
				{
					short s = lstr(rstr,'|/\\');	/* get limited string */
					rstr[15] = 0;
					strcpy(Filters[i++],rstr);
					if (s ne '/' and s ne '|' and s ne '\\')
						break;
					sk1();					/* skip only the delimiter */
				}
				while (i < 23)
					Filters[i++][0] = 0;
			}
#endif
			else
				err = printf("line %d: unimplemented keyword '%s'\n", lnr, rstr);
		}
	}

	strings[envs] = nil;

	if (err and !debug_file)
	{
		printf("hit any key\n");
		bios(2,2);
	}

/*	free(cnf);			/postponed to shutdowm. :-) */
}

void load_accs(void)
{
	char search_path[200];
	char acc[200];
	short fnd;
	_DTA *my_dta = Fgetdta();
	
	sprintf(search_path,"%s*.ACC", acc_path);

	fnd = Fsfirst(search_path, 0xff);
	while(!fnd)
	{
		sprintf(acc, "%s%s", acc_path, my_dta->dta_name);
		launch(NOLOCKING, 3, 0, 0, acc, "", Aes);
		fnd = Fsnext();
	}
}

/*
 * Cleanup on exit
 */
static void Cleanup(void)
{
	XA_CLIENT *client;
	long ex_con;
	
	DIAG((D.appl,-1,"Cleaning up ready to exit....\n"));

	if (svmotv)
	{
		vdi_vec *m,*b,*t;
		vex_motv(P_handle, svmotv, &m);
		vex_butv(P_handle, svbutv, &b);
/*		vex_timv(P_handle, svtimv, &t, 50);
*/	}

	Psignal(SIGCHLD, 0L);
	
	client = client_list;		/* HR */
	while(client)
	{
		XA_CLIENT *next = client->next;
		if (is_client(client))
		{
			DIAG((D.appl,-1,"Terminating:%d:%s:%s\n",client->pid, client->cmd_name, client->name));
			Pkill(client->pid, SIGTERM);
		}
		client = next;
	}

	Syield();

	client = client_list;	/* HR */
	while(client)
	{
		XA_CLIENT *next = client->next;
		if (is_client(client))
		{
			ex_con = Pwaitpid(client->pid, 1, NULL);		/* If client ignored SIGTERM, send SIGKILL */
			if (ex_con == 0)
			{
				DIAG((D.appl,-1,"Killing:%d:%s:%s\n",Client2Pid(client), client->cmd_name, client->name));
				Pkill(client->pid, SIGKILL);
			}
		}
		client = next;
	}


	/* HR: */
	if (half_screen_buffer)
		Mfree(half_screen_buffer);
	if (environment)
		free(environment);
	if (config)
		free(config);
	XA_free_all(Aes);

	unhook_from_vector() ;

	if (MOUSE_dev > 0)
		Fclose(MOUSE_dev);
	
	if (KBD_device > 0)
		Fclose(KBD_device);			/* HR: MOUSE_dev --> KBD_device */

	if (AES_in_pipe > 0)
		Fclose(AES_in_pipe);

	if (Salert_pipe > 0)
		Fclose(Salert_pipe);

#if GENERATE_DIAGS						/* HR */
	/* Close the debug output file */

	if (debug_file > 0)
		Fclose(debug_file);
#endif

	/* Close screen workstation */

DIAGS(("Closing video workstation\n"));
	v_clsvwk(V_handle);
	if (auto_program)
		v_clswk(P_handle);				/* Auto version must close the physical workstation */

	/* Remove semaphores: */
DIAGS(("Deleting semaphores\n"));
	Psemaphore(1, APPL_INIT_SEMA, 0);
/*	Psemaphore(1, TRAP_HANDLER_SEMA, 0);
*/	Psemaphore(1, WIN_LIST_SEMA, 0);
	Psemaphore(1, ROOT_SEMA, 0);
	Psemaphore(1, CLIENTS_SEMA, 0);
	Psemaphore(1, UPDATE_LOCK, 0);
	Psemaphore(1, MOUSE_LOCK, 0);
	Psemaphore(1, FSELECT_SEMA, 0);

DIAGS(("Bye!\n"));
	if (!auto_program)					/* If we weren't an auto program, call appl_exit() to the standard AES */
		appl_exit() ;
}

/*
 * (Re)initialise the mouse device /dev/moose
 */
short init_moose(void)
{
	MOOSE_INIT_COM i_com;
	MOOSE_DCLICK_COM dc_com;

	if (!MOUSE_dev)
	{
		MOUSE_dev = Fopen(moose_name, O_RDWR);
		if (MOUSE_dev < 0)
		{
			printf("Can't open " sbslash "dev" sbslash "moose?\n");
			return false;
		}
	}

	i_com.init_prefix = MOOSE_INIT_PREFIX;			/* Load the command prefix into the command */
	i_com.dum = nil;			/* HR: 19 october 2000; switched over to VMOOSE, the vdi vector using moose. */

	if (Fwrite(MOUSE_dev, 6L, &i_com) == 0)
		printf("Moose init failed\n");
	else
	{
		long dev = 1L<<MOUSE_dev;
		vecs_com.vecs_prefix = MOOSE_VECS_PREFIX;
		/* HR: obtain the addresses of the vdi change routines (in the moose) */
		Fselect(1, &dev, 0, 0);
		if (dev&(1L<<MOUSE_dev))
			Fread(MOUSE_dev, sizeof(MOOSE_VECS_COM), &vecs_com);

		dc_com.dclick_prefix = MOOSE_DCLICK_PREFIX;
		dc_com.dclick_time = double_click_time;

		if (Fwrite(MOUSE_dev, 4L, &dc_com) == 0)
			printf("Moose set dclick time failed\n");
	}

	if (vecs_com.motv)			/* HR */
	{
		vex_motv(P_handle, vecs_com.motv, &svmotv);
		vex_butv(P_handle, vecs_com.butv, &svbutv);
/*		vex_timv(P_handle, vecs_com.timv, &svtimv, 50);
*/	}

	return true;
}

void reopen_moose(void)
{									
	MOOSE_DCLICK_COM dc_com;
	MOUSE_dev = Fopen(moose_name, O_RDWR);
	dc_com.dclick_prefix = MOOSE_DCLICK_PREFIX;
	dc_com.dclick_time = 50;
	/*	dc_com.dclick_time = double_click_time;*/
	if (Fwrite(MOUSE_dev, 4L, &dc_com) == 0)
	{
		DIAG((D.mouse,-1,"moose set dclick time failed\n"));
	}
}

/*
 *	Startup & Initialisation...
 *	- Spawn off any extra programs we need (mouse server, etc).
 *	- Open physical & virtual workstations.
 *	- Install our trap handler.
 *	- Run the xaaes.cnf startup script.
 */

#if 0
/* For tracer */
OBJECT *tr_menu,
       *tr_aicons,
       *tr_alert,
       *tr_about,
       *tr_desk,
       *tr_manager,
       *tr_error,
       *tr_select,
       *tr_fsmenu;
#endif

short main(short argc, char *argv[],char *env[])
{
	short work_in[12];
	short work_out[58];
	short f;
	extern unsigned long wind_handle[];
#if DODGY_MEMORY_PROTECTION
	short proc_handle;
	long protection;
#endif

	{
		char **p = env;
		do
			strings[envs++] = *p++;
		while(*p);
	}

#if !DRAW_TEST
	/* Check that MiNT is actually installed */
	/* Tried to use mintlibs Getcookie, but failed */
	if (Ssystem(-1, 0, 0) != 0)
	{
		BootMessage(0);
		printf("Sorry, XaAES requires MiNT >= 1.15.0 to run.");
#if GENERATE_DIAGS
		bios(2,2);
#endif
		exit(1);
	}

	Pdomain(1);			/* HR The kernel runs in the MiNT domain. */

									 /* 'FSEL' */
	fsel_cookie = Ssystem(S_GETCOOKIE, 0x4653454cL, 0) != 0xffffffff;

	environ = env;				/* HR */

	/* Let's get our MiNT process id being as MiNT is loaded... */
	AESpid = Pgetpid();
#else
	AESpid = 1;
#endif

	/* HR: dynamic window handle allocation. */
	for (f = 0; f < (MAX_WINDOWS/LBITS); f++)
		wind_handle[f]=0;

	memset(active_menu,0,sizeof(active_menu));
	memset(&active_timeout,0,sizeof(active_timeout));

	/* Initialise the object tree display routines */
	init_objects();		/* HR: before parse_cnf() */

	/* HR: static pid array & dynamic client pool */
	/* Initialise the client pool */
	
	for (f = 0; f < MAX_CLIENT; f++)
	{
		XA_CLIENT *client = &clients_pool[f];
		memset(client, 0, sizeof(XA_CLIENT));
		NoClient(client);
		if (f > 0)
			client->next = &clients_pool[f-1];
		else
			client->next = NULL;
		client->prior = NULL;		/* the freelist dont use this */
	}

	/* HR:   They're all in the free_client list :-) */
	free_clients = &clients_pool[MAX_CLIENT-1];
	client_list = NULL;

	for (f = 0; f < MAX_PID; f++)
		Clients[f] = NULL;

	Aes = NewClient(AESpid);		/* So we can speak to and about ourself. */

	Aes->cmd_name = "XaAES";
	Aes->parent = Pgetppid();
	sprintf(Aes->name, "  XaAES System");

#if !DRAW_TEST
	/* Change the protection mode to OS_SPECIAL to allow operation with
	 * memory protection (doesn't work yet, what's wrong?)
	 */
	/* Craig's Note: I think this causes a massive memory leak in the MiNT kernal, so
	 * I've disabled it
	 */
#if DODGY_MEMORY_PROTECTION
	{
	#ifndef F_PROT_S
		#define F_PROT_S	0x20
	#endif
	#ifndef F_OS_SPECIAL
		#define F_OS_SPECIAL	0x8000
	#endif
		/*	Opening "u:\proc\.-1" opens the current process... */
		
		if ((dummy = Fopen("u:" sbslash "proc" sbslash ".-1", O_RDONLY)) >= 0)
		{
			proc_handle = (short)dummy;
			Fcntl(proc_handle, &protection, PGETFLAGS);
			protection &= ~0xf0;
			protection |= F_OS_SPECIAL | F_PROT_S;
			Fcntl(proc_handle, &protection, PSETFLAGS);
			Fclose(proc_handle);
		}
	}
#endif

#endif

	/* Where were we started? */
	
	XaAES_home_drv = Dgetdrv();
	Dgetcwd(XaAES_home, XaAES_home_drv + 1, sizeof(XaAES_home) - 1);

	/* Are we an auto/mint.cnf launched program? */

	/* Note: global[0] (AES version number) is initially zero. */
	
	global[0] = 0;		/* HR: Make sure :-) */
	appl_init();
	auto_program = (global[0] == 0);	/* global[0] still zero? */

	for (f = 0; f < 10; f++)				/* HR start at 0 */
		work_in[f] = 1;
	work_in[10] = 2;
	
	if (auto_program)
	{
		if ((Kbshift(-1) & 3) && (Getrez() == 0))	/* Any shift key and low rez */
			Setscreen((void*)-1L, (void*)-1L, 1, 0);	/* Switch to medium rez */
		else
		{
			/* Set video mode from command line parameter? */			
			if (argc > 2)
			{
				havemode = true;
				ipff_init(0,0,0,nil,argv[2],nil);
				sk();
				switch (tolower(*argv[2]))
				{
				case 'o':  modecode = skc(), oct();  break;
				case 'x':  modecode = skc(), hex();  break;
				case 'b':  modecode = skc(), bin();  break;
				default :  modecode =       idec();  break;
				}

				if (stricmp("-fvideo", argv[1]) == 0) 		/* Falcon Video mode switch */
				{
										/* '_VDO' */
					Ssystem(S_GETCOOKIE, 0x5f56444fL, &falcon);

					if (falcon == 0x00030000L)
					{
						extern  VDIPARBLK _VDIParBlk;
#if __PUREC__
						_VDIParBlk.ptsout[0] = modecode;
#else
						/* FIX_ME: Those who know how to reach ptsout for other
						   compilers libraries, please come forward. :-)
						*/
#endif
						work_in[0] = 5;    /* Ronald Andersson: This should be the mehod for falcon. */
					}

				} else
					if (stricmp("-video", argv[1]) == 0) 	/* Video mode switch */
						work_in[0] = modecode;
					else
						work_in[0] = Getrez() + 2;
			}

			v_opnwk(work_in, &P_handle, work_out);

			printf("\033HPhysical work station opened: %d\n",P_handle);
		}
	} else
	{
		short junk;
		P_handle = graf_handle(&junk, &junk, &junk, &junk);	/* The GEM AES has already been started,  */
									/*  so get the physical workstation handle from it */
	}

	/* Setup the kernel OS call jump table */
	
	setup_k_function_table();


	/* Create a whole wodge of semphores for everything from remembering your mother's birthday
	 * to avoiding an IRA bomb up your arse at work...
	 * (Yes folks, I work in London and don't like getting blown up).
	 */

#if !DRAW_TEST
	Psemaphore(0, APPL_INIT_SEMA, 0);
/*	Psemaphore(0, TRAP_HANDLER_SEMA, 0); */
	Psemaphore(0, WIN_LIST_SEMA, 0);
	Psemaphore(0, ROOT_SEMA, 0);
	Psemaphore(0, CLIENTS_SEMA, 0);
	Psemaphore(0, UPDATE_LOCK, 0);
	Psemaphore(0, MOUSE_LOCK, 0);
	Psemaphore(0, FSELECT_SEMA, 0);
	Psemaphore(0, ENV_SEMA, 0);


	/* Print a text boot message */

	mint = Ssystem(S_OSVERSION,0,0);
	BootMessage(mint);

	/* Patch the AES trap vector to use our OS. */
	hook_into_vector();

	/* Open the MiNT Salert() pipe to be polite about system errors */
	Salert_pipe = Fopen("u:" sbslash "pipe" sbslash "alert", O_CREAT|O_RDWR);

	/* Create the XaAES.cmd introduction pipe */
	
	AES_in_pipe = Fopen(AES_cmd_name, O_CREAT|O_RDWR);

	/* Open the u:/dev/console device to get keyboard input */

	KBD_device = Fopen("u:" sbslash "dev" sbslash "console", O_RDONLY);
	if (KBD_device < 0)
	{
		printf("XaAES ERROR: Can't open /dev/console ?\n");
		Cleanup() ;
		return 1;
	}

	/* Open /dev/moose */
	
	if (!init_moose())
	{
		Cleanup();
		return -1;
	}

#endif
	/* Open us a virtual workstation for XaAES to play with */

	V_handle = P_handle;
	v_opnvwk(work_in, &V_handle, work_out);

	v_hide_c(V_handle);
	vswr_mode(V_handle, MD_TRANS);				/* We run in TRANSPARENT mode for all AES ops (unless otherwise requested) */
	vst_alignment(V_handle, 0, 5, &f, &f);		/* YESss !!! */

	/* Setup the display parameters */

	display.r.x = display.r.y = 0;
	display.r.w = work_out[0] + 1;	/* HR + 1 */
	display.r.h = work_out[1] + 1;	/* HR + 1 */
	display.colours = work_out[13];
	display.display_type = D_LOCAL;
	display.P_handle = P_handle;
	display.V_handle = V_handle;

	display.dial_colours =
		MONO ? bw_default_colours : default_colours;

	vq_extnd(V_handle, 1, work_out);			/* Get extended information */
	display.planes = work_out[4];				/* number of planes in the display */

	half_screen_size = ((long)display.r.w * display.r.h * display.planes) / 16;		/* HR before it's gone */

	/* Set the default clipboard */

	strcpy(scrap_path, "c:" sbslash "clipbrd" sbslash "");


	/* Set the default accessory path */
	
	strcpy(acc_path, "c:" sbslash "");

	/* Parse the standard startup file xaaes.cnf
	 * This can run programs & redirect the debugging output to another file/device
	 */
	 
#if GENERATE_DIAGS		/* FIX_PC  .lst */
	strcpy(debug_path, "debug.lst");			/* By default debugging output goes to the file "./debug.lst"*/
#endif

	sprintf(Aes->home_path, "%c:%s", XaAES_home_drv + 'A', XaAES_home);

	parse_cnf();
	
	/* If we are using anything apart from the system font for windows,
	 * better check for GDOS and load the fonts.
	 */

	if (font_id != 1)
	{
		if (vq_gdos())					/* Yeah, I know, this is assuming the old-style vq_gdos() binding */
			vst_load_fonts(V_handle, 0);
		else
			font_id = 1;
	}


	/* Set standard AES font */
	
	display.standard_font_id = display.small_font_id =
		vst_font(V_handle, font_id);


	/* Select Small font */
	
	display.small_font_point = vst_point(V_handle,
		small_font_point, &f, &display.small_font_height, &f, &f);

				
	/* Select standard font */
	
 	display.standard_font_point = vst_point(V_handle,
 		(display.r.h <= 280) ? medium_font_point : standard_font_point,
		&f, &display.standard_font_height, &f, &f);


	/* Get font information for use by the resource loader */
	
	vqt_attributes(V_handle, work_out) ;
	display.c_max_w = work_out[8];				/* Character cell width */
	display.c_min_w = work_out[8] / 2;			/* Character cell width */
	display.c_max_h = work_out[9];				/* Character cell height */
	display.c_min_h = work_out[9] / 2;			/* Character cell height */

	init_objects();
#if SHOW_LOGO_AT_STARTUP && !FIX_PC &&!DRAW_TEST /* PC binding for Pvfork is unusable */
	/* Display the XaAES logo */
	
	if (Pvfork() eq 0)
	{					/* In child here */
		execl("logo.prg", "XaAES_LOGO", NULL);
	}
#endif


#if GENERATE_DIAGS
	/* Open a diagnostics file? All console output can be considered diagnostics,
	 * so I just redirect the console to the required file/device
	 */
 	 
	if (!D.all.point)
		printf("Debug output initially turned off\n");
#endif

	DIAGS(("Display Device: P_handle=%d, V_handle=%d\n", P_handle, V_handle));
	DIAGS((" size=[%d,%d], colours=%d, bitplanes=%d\n", display.r.w, display.r.h, display.colours, display.planes));

	/* Load the system resource files */
	resource_name = xa_find(RSCNAME);		/* HR */
	if (resource_name)
	{
		system_resources = LoadResources(Aes, resource_name, DU_RSX_CONV, DU_RSY_CONV);
		if (system_resources)
			printf("system_resources=%lx\n", system_resources);
	} else
	{
		printf("ERROR: Can't find/load system resource file '%s'\n",resource_name);
		Cleanup();
		return -1;
	}
#ifdef WIDGNAME
	resource_name = xa_find(WIDGNAME);		/* HR */
	if (resource_name)
	{
		widget_resources = LoadResources(Aes, resource_name, DU_RSX_CONV, DU_RSY_CONV);
		if (widget_resources)
			printf("widget_resources=%lx\n", widget_resources);
	} else
	{
		printf("ERROR: Can't find/load widget resource file '%s'\n",resource_name);
		Cleanup();
		return -1;
	}
#endif

#if 0
 	tr_menu = ResourceTree(system_resources, SYSTEM_MENU);
    tr_aicons = ResourceTree(system_resources, ALERT_ICONS);
    tr_alert = ResourceTree(system_resources, ALERT_BOX);
    tr_about = ResourceTree(system_resources, ABOUT_XAAES);
    tr_desk = ResourceTree(system_resources, DEF_DESKTOP);
    tr_manager = ResourceTree(system_resources, TASK_MANAGER);
    tr_error = ResourceTree(system_resources, SYS_ERROR);
    tr_select = ResourceTree(system_resources, FILE_SELECT);
    tr_fsmenu = ResourceTree(system_resources, FSEL_MENU);
#endif

#if FILESELECTOR
	/* HR: Do some itialisation */
	init_fsel();
#endif

	/* Create the root (desktop) window
	 * - We don't want messages from it, so make it a NO_MESSAGES window
	 */
	
	DIAGS(("creating root window\n"));

	root_window = create_window(
							NOLOCKING,
							nil,
							AESpid,
							false,
							XaMENU|					/* HR: menu standard widget */
							NO_MESSAGES,
							-1,						/* HR: -1, no frame, overscan window */
							 display.r,				/*  current size */
							 &display.r,			/*  maximum size (NB default would be root_window->wa) */
							 nil );					/* need no remembrance */
/*	root_window->handle = 0;  HR */
#if !TWOLISTS
	root_window->is_open = TRUE;				/* Flag window as open	*/
#endif

	/* Tack a menu onto the root widget */

	Aes->std_menu.tree = ResourceTree(system_resources, SYSTEM_MENU);	/* HR widget.tree */
	Aes->std_menu.owner = AESpid;

	fix_menu(Aes->std_menu.tree,true);										/* HR */
	set_menu_widget(root_window,click_menu_widget, &Aes->std_menu);		/* HR */
#if 0		/* not needed anymore since the menu is a standard widget */
/* the below is now perfectly done by calc_work_area() */
	root_window->wa.x = 0;
	root_window->wa.w = display.r.w;
	root_window->wa.y = sys_menu_loc.r.y + sys_menu_loc.r.h + 1;
	root_window->wa.h = root_window->r.h - root_window->wa.y;
#endif

	DIAGS(("menu widget set\n"));


	/* Fix up the file selector menu */
	fix_menu(ResourceTree(system_resources, FSEL_MENU),false);

	/* Standard Widget Set from widget resource file */
	
	def_widgets = ResourceTree(widget_resources, WIDGETS);
	DIAGS(("widget set at %lx\n", def_widgets));

	/* Fix up the window widget bitmaps and any others we might be using
   	 * (Calls vr_trnfm() for all the bitmaps)
   	 * HR: No, it doesnt! ;-)
   	 */
	 
	DIAGS(("fixing up widgets\n"));
	fix_widgets(def_widgets);

	/* Set a default desktop */
	
	DIAGS(("setting default desktop\n"));
	set_desktop(ResourceTree(system_resources, DEF_DESKTOP));
	(desktop + DESKTOP_LOGO)->r.x = (root_window->wa.w - (desktop + DESKTOP_LOGO)->r.w) / 2;
	(desktop + DESKTOP_LOGO)->r.y = (root_window->wa.h - (desktop + DESKTOP_LOGO)->r.h) / 2;
	Aes->desktop = desktop;

	DIAGS(("setting up task manager\n"));
	
#if !DRAW_TEST
/* HR moved the title to set_slist_widget() */
	/* Setup the task manager */
	set_scroll(ResourceTree(system_resources, TASK_MANAGER), TM_LIST);

	/* Setup the file selector */
	set_scroll(ResourceTree(system_resources, FILE_SELECT), FS_LIST);

	/* Setup the System Alert log */
	set_scroll(ResourceTree(system_resources, SYS_ERROR), SYSALERT_LIST);

#endif
	/* Display the root window */
	
	DIAGS(("About to display root window\n"));

#if TWOLISTS
	open_window(NOLOCKING, AESpid, root_window->handle, display.r);
#else
	display_non_topped_window(NOLOCKING, 1, root_window, NULL);
	generate_rect_list(NOLOCKING, root_window);

	display_non_topped_window(NOLOCKING, 2, root_window, NULL);
#endif
	
	/* Initial iconified window coords */
	
	iconify_w = ICONIFIED_W;
	iconify_h = ICONIFIED_H;
	iconify_x = 0;
	iconify_y = display.r.y + display.r.h - iconify_h - 2; /* HR: - 2 */;


	/* Set our process priority
	 * - a high negative value here improves performance a lot, 
	 * so I set it to -20 in XA_DEFS.H. This doesn't hurt the rest
	 * of the systems performance, as there are no busy wait loops
	 * in the server, and it spends most of its time blocked
	 * waiting for commands.
	 */


#if !DRAW_TEST
	Pnice(-1);		/* 1 less than MiNT itself */


	/* Catch SIGCHLD to spot dead children */
	
	Psignal(SIGCHLD, (long)HandleSIGCHLD);

	/* Catch SIGINT and SIGQUIT so we can shutdown with CTRL+ALT+C */
	
	Psignal(SIGINT, (long)HandleSIGINT);
	Psignal(SIGQUIT, (long)HandleSIGINT);

	/* Load Accessories */
	
	DIAGS(("loading accs\n"));
	load_accs();

	/* HR: I just like to have the unlocks at the same level as the locks. */

	/* Unlock the semaphores...we're ready to go */

	Sema_Dn(APPL_INIT_SEMA);
/*	Sema_Dn(TRAP_HANDLER_SEMA);
*/	Sema_Dn(WIN_LIST_SEMA);
	Sema_Dn(ROOT_SEMA);
	Sema_Dn(CLIENTS_SEMA);
	Sema_Dn(UPDATE_LOCK);
	Sema_Dn(MOUSE_LOCK);
	Sema_Dn(FSELECT_SEMA);
	Sema_Dn(ENV_SEMA);

	/* Turn on the mouse cursor */
	
	v_show_c(V_handle, 0);		/* 0 = reset */

	/* Call the main command interpreter kernel */
	
	DIAG((D.appl,-1,"going to the kernel\n"));
	in_kernel = true;

	XaAES();


	/* Closedown & exit */
	
	Cleanup();

#else				/* draw_test */
	{
	void cancel_fsel(char *path, char *file);
	RECT r = {32,32,256,256};
	short kind = NAME
				|INFO
				|CLOSER
				|FULLER
				|SMALLER
				|SIZER
				|VSLIDE
				|UPARROW
				|HSLIDE
				|LFARROW
				;
		XA_WINDOW *w;
		v_clrwk(V_handle);
		NewClient(2);
		w = create_window(NOLOCKING, nil,2,false,kind,MG,display.r, &display.r, nil);
		open_window(NOLOCKING,2,w->handle,r);
		display_window(NOLOCKING,w);		/* fake all locks */
	/*	do_form_alert(NOLOCKING, 1,"[ 1 ] [ Test | de | form_alert ] [ OK | apply | Cancel ]",2);
	*/	open_fileselector(NOLOCKING,2,"D:\AAAA\*.*","Test fsel",NULL,cancel_fsel);
		bios(2,2);
	}
#endif
	return 0;
}

/*
void dial_position(RECT *rem, OBJECT *form)
{
	if (rem->w)
		form->r = *rem;
	else
		form->r.x = (display.r.w - form->r.w) / 2,
		form->r.y = (display.r.h - form->r.h) / 2;
}
*/

XA_WINDOW *about_window = nil;	/* HR */

WindowDisplay about_destructor	/* HR */
{
	about_window = nil;
	return TRUE;
}

void open_about(LOCK lock)
{
	XA_WINDOW *dialog_window;
	OBJECT *form = ResourceTree(system_resources, ABOUT_XAAES);
	XA_WIDGET_LOCATION dialog_toolbar_loc = {LT, 0, ICON_H};		/* HR */
	static RECT remember = {0,0,0,0};

	if (!about_window)
	{
		/* HR */
	/* Work out sizing */
		if (!remember.w)
			center_form(form, ICON_H),
			calc_window(AESpid, WC_BORDER, CLOSE|NAME, &form->r, &remember);		/* HR */

	/* Create the window */
		dialog_window = create_window(lock, nil,
							AESpid,
							false,
							CLOSE|NAME|
							MOVE|
							NO_MESSAGES|
							NO_WORK,
							MG, remember, nil, &remember);

		dialog_window->created_by_FMD_START = FALSE;

	/* Set the window title */
		dialog_window->widgets[XAW_TITLE].stuff = "About XaAES....";

	/* Set version date */
		((TEDINFO *)(form + ABOUT_DATE)->ob_spec)->te_ptext = __DATE__;

		set_toolbar_widget(lock, dialog_window, dialog_toolbar_loc, form);

		((XA_WIDGET_TREE *)dialog_window->widgets[XAW_TOOLBAR].stuff)->owner = AESpid;

		dialog_window->widgets[XAW_TOOLBAR].behaviour[XACB_DCLICK] = NULL;
		dialog_window->widgets[XAW_TOOLBAR].behaviour[XACB_CLICK] = NULL;
		dialog_window->widgets[XAW_TOOLBAR].behaviour[XACB_DRAG] = NULL;

	/* Set the window destructor */
		dialog_window->destructor = about_destructor;
#if TWOLISTS
		open_window(lock, AESpid, dialog_window->handle, remember);
#else
		dialog_window->is_open = TRUE;
#endif
		about_window = dialog_window;
	}
#if TWOLISTS
	else
#endif
	if (about_window != window_list)
	{
		focus = pull_wind_to_top(lock, about_window);			/* HR */
		after_top(lock, true);
		display_non_topped_window(lock, 3, about_window, NULL);
	}
}

#if 0
/* HR: once used to debug a window_list corruption.
       also a example of how to use this trace facility. */
long xa_trace(char *t)
{
	long l = 0;
	if (in_kernel)
	if (   tr_menu != ResourceTree(system_resources, SYSTEM_MENU)
	    || tr_aicons != ResourceTree(system_resources, ALERT_ICONS)
	    || tr_alert != ResourceTree(system_resources, ALERT_BOX)
	    || tr_about != ResourceTree(system_resources, ABOUT_XAAES)
	    || tr_desk != ResourceTree(system_resources, DEF_DESKTOP)
	    || tr_manager != ResourceTree(system_resources, TASK_MANAGER)
	    || tr_error != ResourceTree(system_resources, SYS_ERROR)
	    || tr_select != ResourceTree(system_resources, FILE_SELECT)
	    || tr_fsmenu != ResourceTree(system_resources, FSEL_MENU)
		)
		l+=sprintf(t, "T* ");
	return l;
}
#endif
