/*
 * XaAES - XaAES Ain't the AES
 *
 * A multitasking AES replacement for MiNT
 *
 */

#include <stdlib.h>
#include <osbind.h>
#include <string.h>
#ifdef LATTICE
#undef abs		/* MiNTlib (PL46) #define is buggy! */
#define abs(i)	__builtin_abs(i)
#endif
#include RSCHNAME

#include "xa_types.h"
#include "xa_globl.h"

#include "rectlist.h"
#include "objects.h"
/* HR: for windowed list boxes */
#include "c_window.h"
#include "widgets.h"

/* HR: pxy wrapper functions (Beware the (in)famous -1 bug */
/* Also vsf_perimeter only works in XOR writing mode */

void write_menu_line(RECT *cl)
{
	short pnt[4];
	pnt[0] = cl->x;
	pnt[1] = cl->y + MENU_H;
	pnt[2] = cl->x + cl->w - 1;
	pnt[3] = pnt[1];
	v_pline(V_handle,2,pnt);
}

void rtopxy(int *p, const RECT *r)
{
	*p++ = r->x;
	*p++ = r->y;
	*p++ = r->x + r->w-1; 
	*p   = r->y + r->h-1;
}

void ritopxy(int *p, short x, short y, short w, short h)
{
	*p++ = x;
	*p++ = y;
	*p++ = x + w-1; 
	*p   = y + h-1;
}

void line(short hl,short x,short y,short x1,short y1)
{
	short pxy[4];

	pxy[0]=x;pxy[2]=x1;
	pxy[1]=y;pxy[3]=y1;
	v_pline(hl,2,pxy);
}

void bar(short d,  short x, short y, short w, short h)
{
	short l[4];
	x -= d, y -= d, w += d+d, h += d+d;
	l[0] = x;
	l[1] = y;
	l[2] = x+w-1;
	l[3] = y+h-1;
	v_bar(V_handle, l);
}

void gbar(short d, RECT *r)	/* for perimeter = 0 */
{
	short l[4];
	l[0] = r->x - d;
	l[1] = r->y - d;
	l[2] = r->x + r->w + d - 1;
	l[3] = r->y + r->h + d - 1;
	v_bar(V_handle, l);
}

void p_bar(short d, short x, short y, short w, short h)	/* for perimeter = 1 */
{
	short l[10];
	x -= d, y -= d, w += d+d, h += d+d;
	l[0] = x+1;	/* only the inside */
	l[1] = y+1;
	l[2] = x+w-2;
	l[3] = y+h-2;
	v_bar(V_handle, l);
	l[0] = x;
	l[1] = y;
	l[2] = x+w-1;
	l[3] = y;
	l[4] = x+w-1;
	l[5] = y+h-1;
	l[6] = x;
	l[7] = y+h-1;
	l[8] = x;
	l[9] = y+1;		/* beware Xor mode :-) */
	v_pline(V_handle,5,l);
}

void p_gbar(short d, RECT *r)	/* for perimeter = 1 */
{
	short l[10];
	short x = r->x - d,
	      y = r->y - d,
	      w = r->w + d+d,
	      h = r->h + d+d;
	l[0] = x+1;	/* only the inside */
	l[1] = y+1;
	l[2] = x+w-2;
	l[3] = y+h-2;
	v_bar(V_handle, l);
	l[0] = x;
	l[1] = y;
	l[2] = x+w-1;
	l[3] = y;
	l[4] = x+w-1;
	l[5] = y+h-1;
	l[6] = x;
	l[7] = y+h-1;
	l[8] = x;
	l[9] = y+1;		/* beware Xor mode :-) */
	v_pline(V_handle,5,l);
}

void box(short d, short x, short y, short w, short h)
{
	short l[10];
	x -= d, y -= d, w += d+d, h += d+d;
	l[0] = x;
	l[1] = y;
	l[2] = x+w-1;
	l[3] = y;
	l[4] = x+w-1;
	l[5] = y+h-1;
	l[6] = x;
	l[7] = y+h-1;
	l[8] = x;
	l[9] = y+1;		/* for Xor mode :-) */
	v_pline(V_handle,5,l);
}

void gbox(short d, RECT *r)
{
	short l[10];
	short x = r->x - d,
	      y = r->y - d,
	      w = r->w + d+d,
	      h = r->h + d+d;
	l[0] = x;
	l[1] = y;
	l[2] = x+w-1;
	l[3] = y;
	l[4] = x+w-1;
	l[5] = y+h-1;
	l[6] = x;
	l[7] = y+h-1;
	l[8] = x;
	l[9] = y+1;		/* for Xor mode :-) */
	v_pline(V_handle,5,l);
}

void tl_hook(short d, RECT *r, short col)
{			
	short pnt[6];
	short x = r->x - d,
	      y = r->y - d,
	      w = r->w + d+d,
	      h = r->h + d+d;
	vsl_color(V_handle, col);
	pnt[0] = x;
	pnt[1] = y + h - 1;
	pnt[2] = x;
	pnt[3] = y;
	pnt[4] = x + w - 1;
	pnt[5] = y;
	v_pline(V_handle, 3, pnt);
}

void br_hook(short d, RECT *r, short col)
{
	short pnt[6];
	short x = r->x - d,
	      y = r->y - d,
	      w = r->w + d+d,
	      h = r->h + d+d;
	vsl_color(V_handle, col);
	pnt[0] = x;
	pnt[1] = y + h - 1;
	pnt[2] = x + w - 1;
	pnt[3] = y + h - 1;
	pnt[4] = x + w - 1;
	pnt[5] = y;
	v_pline(V_handle, 3, pnt);
}


void write_selection(RECT *r)
{
	vswr_mode(V_handle, MD_XOR);
	vsf_color(V_handle, BLACK);
	vsf_interior(V_handle, FIS_SOLID);
	gbar(0, r);
	vswr_mode(V_handle, MD_TRANS);
}

void XA_3D_pushbutton(short d, RECT *r, short state, short flags, short fill)
{
	short pnt[6]; short selected = state&SELECTED;

	/* HR: do this adaptations here once!! It is also easier to maintain and adapt.
	   Now you have the propertions of 3D stuff to the OBJECT size centralized.
	   This immensely reduces confusion.
	*/

	d++;		/* 3D buttons are at least 1 outlined */

	if (!MONO  && (flags & DEFAULT))
		d++;

	if (fill)
	{
		vsf_color(V_handle, display.dial_colours.bg_col);
		gbar(d+1, r);						/* inside bar */
	}

	if (MONO || (flags & EXIT) /* || (flags & DEFAULT) */)
	{
		vsl_color(V_handle, display.dial_colours.fg_col);
		gbox(d+1, r);					/* outside box */
	}

	/* 'winkelhaken' */
	br_hook(d, r, selected ? display.dial_colours.t_l_col : display.dial_colours.b_r_col);
	tl_hook(d, r, selected ? display.dial_colours.b_r_col : display.dial_colours.t_l_col);

	if (flags & DEFAULT)
	{
		d--;
		br_hook(d, r, selected ? display.dial_colours.t_l_col : display.dial_colours.b_r_col);
		tl_hook(d, r, selected ? display.dial_colours.b_r_col : display.dial_colours.t_l_col);
	}

	vsl_color(V_handle, display.dial_colours.b_r_col);
}

/* should become c:\s...ng\foo.bar */
char *cramped_name(void *s, char *t, short w)
{
	char *q=s,*p=t;
	int l = strlen(q),
		d = l - w,
		h = (l-3)/2;

	if (d > 0)
	{
		if (w <= 12)		/* 8.3 */
			return q+l-w;	/* only the last ch's */
		h = (w-3)/2;
		strncpy(p,q,h);
		p+=h;
		*p++='.';
		*p++='.';
		*p++='.';
		strcpy(p,q+l-h);
		return t;
	}
	return s;
}

char *clipped_name(void *s, char *t, short w)
{
	char *q=s;
	int l = strlen(q);

	if (l > w)
	{
		strncpy(t,q,w);
		t[w]=0;
		return t;
	}
	return s;
}

/* HR: 1 (good) set of routines for screen saving */

long calc_back(RECT *r, short planes)
{
	return 2L * planes
			  * ((r->w + 15) / 16)
			  * r->h;
}

void *form_save(short d, RECT r, void *area)
{
	MFDB Mscreen={0};
	MFDB Mpreserve;
	short pnt[8];
	
	r.x-=d, r.y-=d, r.w+=2*d, r.h+=2*d;

	rtopxy(pnt, &r);
	ritopxy(pnt+4,0,0,r.w,r.h);
DIAG((D.menu,-1,"Mpreserve\n"));
	Mpreserve.fd_w = r.w;
	Mpreserve.fd_h = r.h;
	Mpreserve.fd_wdwidth = (r.w + 15) / 16;
	Mpreserve.fd_nplanes = display.planes;
	Mpreserve.fd_stand = 0;

	if (area == nil)
		area = malloc(calc_back(&r,display.planes));

	if (area)
	{
		Mpreserve.fd_addr = area;
		vro_cpyfm(V_handle, S_ONLY, pnt, &Mscreen, &Mpreserve);
	}
	return area;
}

void form_restore(short d, RECT r, void *area)
{
	MFDB Mscreen={0};
	MFDB Mpreserve;
	short pnt[8];
	
	if (!area) return;

	r.x-=d, r.y-=d, r.w+=2*d, r.h+=2*d;

	rtopxy(pnt+4, &r);
	ritopxy(pnt,0,0,r.w,r.h);

	Mpreserve.fd_w = r.w;
	Mpreserve.fd_h = r.h;
	Mpreserve.fd_wdwidth = (r.w + 15) / 16;
	Mpreserve.fd_nplanes = display.planes;
	Mpreserve.fd_stand = 0;
	Mpreserve.fd_addr = area;
	vro_cpyfm(V_handle, S_ONLY, pnt, &Mpreserve, &Mscreen);
	free(area);
}

void form_copy(RECT *fr, RECT *to)
{
	short pnt[8];
	MFDB Mscreen={0};
	rtopxy(pnt,fr);
	rtopxy(pnt+4,to);
	v_hide_c(V_handle);
	vro_cpyfm(V_handle, S_ONLY, pnt, &Mscreen, &Mscreen);
	v_show_c(V_handle, 1);
}

void shadow_object(short state, RECT *rp, OBJC_COLORWORD *colourword, short border_thick)
{
	RECT r = *rp;
	short offset, increase;

	/*	Are we shadowing this object? (Borderless objects aren't shadowed!) */
	if (border_thick && (state & SHADOWED))
	{
		short i;
		if (border_thick < -4) border_thick = -4;
		if (border_thick >  4) border_thick =  4;

		offset = border_thick > 0 ? border_thick : 0;
		increase = -border_thick + 1;

		r.x += offset;
		r.y += offset;
		r.w += increase;
		r.h += increase;

		for (i = 0; i < abs(border_thick)*2; i++)
		{
			r.w += i, r.h += i;
			br_hook(0, &r, colourword->borderc);
		}
#if 0
/* HR: This wrong, what about I-boxes ? */
		if (border_thick > 0)
		{
			offset = border_thick;		/* inside */
			increase = border_thick;
		} else
		{
			offset = 0;					/* outside */
			increase = -3 * border_thick;
		}
		vsf_color(V_handle, colourword->borderc);
		vsf_interior(V_handle, FIS_SOLID);
 
		ritopxy(coords, x + offset, y + offset, ob->r.w + increase, ob->r.h + increase);
		v_bar(V_handle, coords);
#endif
	}
}

static
const short
	selected_colour[]   = {1, 0, 13, 15, 14, 10, 12, 11, 8, 9, 5, 7, 6, 2, 4, 3},
	selected3D_colour[] = {1, 0, 13, 15, 14, 10, 12, 11, 9, 8, 5, 7, 6, 2, 4, 3};

static
void set_colours(OBJECT *ob, OBJC_COLORWORD *colourword)
{
	short colourmode = !MONO;
	
	/* Note: `colourword->opaque' applies *only* to the text
		part of an object!!!!!! */
	vswr_mode(V_handle, MD_REPLACE);

	vsf_interior(V_handle, FIS_PATTERN);
	if (colourword->pattern == 7)
	{
		vsf_style(V_handle, 8);
	} else
	{
		if (colourword->pattern == 0)
		{
			vsf_style(V_handle, 8);
			if ((colourword->fillc == 0) && (ob->ob_flags & FLD3DANY))	/* Object inherits default dialog background colour? */
			{
				vswr_mode(V_handle, MD_TRANS);
				colourword->fillc = display.dial_colours.bg_col;
			} else
			{
				colourword->fillc = WHITE;
			}
		} else
		{
			vsf_style(V_handle, colourword->pattern);
		}
	}

	if (colourmode && (ob->ob_state & SELECTED))
		if (ob->ob_flags & FLD3DANY)				/* Allow a different colour set for 3d push  */
			vsf_color(V_handle, selected3D_colour[colourword->fillc]);
		else
			vsf_color(V_handle, selected_colour[colourword->fillc]);
	else
		vsf_color(V_handle, colourword->fillc);

	vst_color(V_handle, colourword->textc);
	
	vsf_perimeter(V_handle, 0);
}

/*
 * Format a G_FTEXT type text string from its template,
 * and return the real position of the text cursor.
 */
/* HR: WRONG_LEN
   It is a very confusing here, edit_pos is always (=1) passed as tedinfo->te_tmplen.
   which means that this only works if that field is wrongly used as the text corsor position.
   A very bad thing, because it is supposed to be a constant describing the amount of memory
   allocated to the template string.
*/

static
short format_dialog_text(char *text_out, char *template, char *text_in, short edit_pos)
{
	short index = 0, tpos = 0, max = strlen(template),
/* HR: In case a template ends with '_' and the text is completely filled, edit_index was indeterminate. :-)  */
	edit_index = max;

	while(*template)
	{
		if (*template != '_')
			*text_out++ = *template;
		else				/* Found text field */
		{
			if (tpos == edit_pos)
				edit_index = index;
				
			if (*text_in)
				*text_out++ = *text_in++;
			else
				*text_out++ = '_';

			tpos++;		
		}
		template++;
		index++;
	}

	*text_out = '\0';
	if (edit_index >= max)			/* HR: keep visible at end */
		edit_index--;
	return edit_index;
}

/* HR: implement odc_p->x,y */
/* HR: Modifications: set_text(...  &gr, &cr, temp_text ...)
 *     cursor alignment in centered text.
 *     Justification now integrated in set_text (v_gtext isolated).
 *     Preparations for positioning cursor in proportional fonts.
 *     Moved a few calls.
	pbox(hl,ext[0]+x,ext[1]+y,ext[4]+x-1,ext[5]+y-1);
 */
static
void set_text(OBJECT *ob,
				RECT *gr,
				RECT *cr,
				char *temp_text,
				OBJC_COLORWORD *colourword,
				short *border_thick,
				RECT r)
{
	TEDINFO *textblk = (TEDINFO *)ob_spec(ob);
	RECT rtn;
	short temp, w, h, cur_x = 0;
	unsigned short *t = (unsigned short *)colourword;
	int e[8];
	
	*t = (unsigned short)textblk->te_color;
	
	*border_thick = textblk->te_thickness;

	switch(textblk->te_font)	/* Set the correct text size & font */
	{
	case TE_GDOS_PROP:		/* Use a proportional SPEEDOGDOS font (AES4.1 style) */
	case TE_GDOS_MONO:		/* Use a monospaced SPEEDOGDOS font (AES4.1 style) */
	case TE_GDOS_BITM:		/* Use a GDOS bitmap font (AES4.1 style) */
		vst_font(V_handle, textblk->te_fontid);
		vst_point(V_handle, textblk->te_fontsize, &temp, &temp, &temp, &temp);
		rtn.w = display.c_max_w;
		rtn.h = display.c_max_h;
		break;
	case TE_STANDARD:		/* Use the standard system font (probably 10 point) */
		rtn.w = display.c_max_w;
		rtn.h = display.c_max_h;
		break;
	case TE_SMALL:			/* Use the small system font (probably 8 point) */
		vst_font(V_handle, display.small_font_id);
		vst_point(V_handle, display.small_font_point, &temp, &temp, &temp, &temp);
		rtn.w = display.c_min_w;
		rtn.h = display.c_min_h;
		break;
	}

/* HR: use vqt_extent to obtain x, because it is almost impossible, or
 *	at least very unnecessary tedious to position the cursor.
 *	vst_alignment is not needed anymore.
 */
	/* after vst_font & vst_point */

	if (temp_text)
		cur_x = format_dialog_text(temp_text, textblk->te_ptmplt, textblk->te_ptext,textblk->te_tmplen);
	else
		temp_text = textblk->te_ptext;

	vqt_extent(V_handle, temp_text, e);

	w = e[4] - e[6];		/* oberen rechten minus oberen linken x coord */
	h = -(e[1] - e[7]);		/* unteren linken minus oberen linken y coord
							   vqt_extent uses a true Cartesion coordinate system
							   How about that? :-)
							   A mathematicion lost among nerds!
							*/
	switch(textblk->te_just)			/*Set text alignment - why on earth did */
	{
										/* Atari use a different horizontal alignment */
	case 0:			/* left */			/* code for GEM to the one the VDI uses? */
		rtn.x = r.x;
		break;
	case 1:			/* right */
		rtn.x = r.x + r.w - w;
		break;
	case 2:			/* centered */
		rtn.x = r.x + (r.w - w) / 2;
		break;
	}

	rtn.y = r.y + (r.h - h) / 2;

	*gr = rtn;

	if (cr)
	{
		cr->x = rtn.x + cur_x * rtn.w;	/* non prop font only */
		cr->y = r.y;
		cr->w = rtn.w;
		cr->h = rtn.h;
	}

	shadow_object(ob->ob_state, &r, colourword, *border_thick);	/* disconnect from object */
	set_colours(ob, colourword);
}

/* HR: implement odc_p->x,y in all ObjectDisplay functions */

#define done(x) (*odc_p->state_mask&=~(x))

/*
 *	Draw a box (respecting 3d flags)
 */
ObjectDisplay d_g_box	/* (ODC_PARM *odc_p) */
{
	RECT r = odc_p->r;
	OBJECT *ob = odc_p->tree + odc_p->object;
	OBJC_COLORWORD *colourword;
	unsigned short zap;
	short border_thick;

	colourword = (OBJC_COLORWORD *)&zap;
	zap = (unsigned short)ob_spec(ob) & 0xffff;
	border_thick = thickness(ob);
	shadow_object(ob->ob_state, &r, colourword, border_thick);
	set_colours(ob, colourword);

	if ((ob->ob_flags & FLD3DANY) != 0 && border_thick)		/* HR: There must be border */
	{
		XA_3D_pushbutton(0, &r, ob->ob_state, 0, 1);
		done(SELECTED);
	} else
	{
		gbar(0, &r);	/* display inside */

		if (border_thick)	/* Display a border? */
			g2d_box(border_thick, &r, colourword->borderc);
	}
}

/*
 *	Display a boxchar (respecting 3d flags)
 */
ObjectDisplay d_g_boxchar	/* (ODC_PARM *odc_p) */
{
	RECT r = odc_p->r;
	OBJECT *ob = odc_p->tree + odc_p->object;
	OBJC_COLORWORD *colourword;
	unsigned short zap, selected = ob->ob_state & SELECTED;		/* HR */
	short border_thick, coords[4], tx, ty, temp;
	char temp_text[2];

	colourword = (OBJC_COLORWORD *)&zap;
	
	temp_text[0] = (char)((((unsigned long)ob_spec(ob)) & 0xff000000L) >> 24);
	temp_text[1] = '\0';
	zap = (unsigned short)ob_spec(ob) & 0xffff;
	border_thick = thickness(ob);
	shadow_object(ob->ob_state, &r, colourword, border_thick);

	set_colours(ob, colourword);
	
	tx = r.x + ((r.w - display.c_max_w) / 2);	/* Centre the text in the box */
	ty = r.y + ((r.h - display.c_max_h) / 2);

	vst_color(V_handle, colourword->textc);

	if ((ob->ob_flags & FLD3DANY) != 0 && border_thick) /* HR */
	{
		XA_3D_pushbutton(0, &r, ob->ob_state, 0, 1);
		if (ob->ob_state & SELECTED)
		{
			tx += PUSH3D_DISTANCE;
			ty += PUSH3D_DISTANCE;
		}
#if T3DREP			/*	HR 3D text always transparent */
		vswr_mode(V_handle, colourword->opaque ? MD_REPLACE : MD_TRANS);
#endif
		v_gtext(V_handle, tx, ty, temp_text);
		done(SELECTED);
	} else
	{
	/*	if (colourword->opaque)*/
			gbar(0, &r);

		vswr_mode(V_handle, colourword->opaque ? MD_REPLACE : MD_TRANS);
		v_gtext(V_handle, tx, ty, temp_text);

		if (selected)				/* HR */
		{
			write_selection(&r);
			done(SELECTED);		/* HR: before borders */
		}

		if (border_thick)	/* Display a border? */
			g2d_box(border_thick, &r, colourword->borderc);
	}
}

/* HR: Modifications: set_text(...  &gr, &cr, temp_text ...)
 *     cursor alignment in centered text.
 *     Justification now integrated in set_text (v_gtext isolated).
 *     Preparations for positioning cursor in proportional fonts.
 *     Moved some calls
 */
ObjectDisplay d_g_text	/* (ODC_PARM *odc_p) */
{
	OBJECT *ob = odc_p->tree + odc_p->object;
	RECT gr;
	short d;
	OBJC_COLORWORD *colourword;
	TEDINFO *textblk;
	unsigned short zap;
	short border_thick = 0;

	textblk = (TEDINFO *)ob_spec(ob);
	colourword = (OBJC_COLORWORD *)&zap;

	set_text(ob, &gr, NULL, NULL, colourword, &border_thick, odc_p->r);

	vswr_mode(V_handle, colourword->opaque ? MD_REPLACE : MD_TRANS);
	v_gtext(V_handle, gr.x, gr.y, textblk->te_ptext);

	vst_font(V_handle, display.standard_font_id);
	vst_point(V_handle, display.standard_font_point, &d, &d, &d, &d);
}

/*
 *	Draw a boxtext object
 */

/* HR: Modifications: set_text(...  &gr, &cr, temp_text ...)
 *     cursor alignment in centered text.
 *     Justification now integrated in set_text (v_gtext isolated).
 *     Preparations for positioning cursor in proportional fonts.
 *     Moved some calls
 */
ObjectDisplay d_g_boxtext /* (ODC_PARM *odc_p) */
{
	RECT r = odc_p->r;
	OBJECT *ob = odc_p->tree + odc_p->object;
	RECT gr;
	short d;
	OBJC_COLORWORD *colourword;
	TEDINFO *textblk;
	unsigned short zap;
	short coords[4], selected = ob->ob_state & SELECTED;
	short border_thick = 0;

	textblk = (TEDINFO *)ob_spec(ob);
	colourword = (OBJC_COLORWORD *)&zap;

	set_text(ob, &gr, NULL, NULL, colourword, &border_thick, r);

	if (ob->ob_flags & FLD3DANY)
	{
		XA_3D_pushbutton(0, &r, ob->ob_state, 0, 1);
		if (selected)
		{
			gr.x += PUSH3D_DISTANCE;
			gr.y += PUSH3D_DISTANCE;
		}
DIAG((D.o,-1,"Opaque\n"));
#if T3DREP			/*	HR 3D text always transparent */
		vswr_mode(V_handle, colourword->opaque ? MD_REPLACE : MD_TRANS);
#endif
		v_gtext(V_handle, gr.x, gr.y, textblk->te_ptext);
		done(SELECTED);		/* HR */
	} else
	{
/*		if (colourword->opaque)*/
			gbar(0, &r);
				
		vswr_mode(V_handle, colourword->opaque ? MD_REPLACE : MD_TRANS);
		v_gtext(V_handle, gr.x, gr.y, textblk->te_ptext);

		if (selected)
		{
			write_selection(&r);
			done(SELECTED);		/* HR: before borders */
		}

		if (border_thick)	/* Display a border? */
		{
			vswr_mode(V_handle, MD_REPLACE);
			g2d_box(border_thick, &r, colourword->borderc);
		}
	}
	vst_font(V_handle, display.standard_font_id);
	vst_point(V_handle, display.standard_font_point, &d, &d, &d, &d);
}

/* HR: Huge generalizations. */
ObjectDisplay d_g_button	/* (ODC_PARM *odc_p) */
{
	RECT r = odc_p->r;
	OBJECT *ob = odc_p->tree + odc_p->object;
	unsigned short zap = 0x11f8;
	short border_thick = -1;
	short temp, tx, ty, selected;
	char *text = (char *)ob_spec(ob);

	selected = ob->ob_state & SELECTED;
	
	if (ob->ob_flags & EXIT)
		border_thick--;
	if (ob->ob_flags & DEFAULT)
		border_thick--;
	ty = r.y + ((r.h - display.c_max_h) / 2);

	shadow_object(ob->ob_state, &r, (OBJC_COLORWORD *)&zap, border_thick);

	vst_alignment(V_handle, 1, 5, &temp, &temp);
	vst_color(V_handle, BLACK);

	tx = r.x + (r.w / 2);

	if (ob->ob_flags & FLD3DANY)
	{
		XA_3D_pushbutton(0, &r, ob->ob_state, ob->ob_flags, 1);
		if (selected)
		{
			tx += PUSH3D_DISTANCE;
			ty += PUSH3D_DISTANCE;
		}

		if (text)
		{
			vswr_mode(V_handle,  MD_TRANS);
			v_gtext(V_handle, tx, ty, text);
		}
	} else
	{
		vswr_mode(V_handle, MD_REPLACE);
		vsf_interior(V_handle, FIS_SOLID);
		vsf_color(V_handle, selected ? BLACK : WHITE);
		gbar(-border_thick, &r);		/* display inside bar */		

		if (text)
		{
			vswr_mode(V_handle,  MD_TRANS);
			vst_color(V_handle, selected ? WHITE : BLACK);
			v_gtext(V_handle, tx, ty, text);
		}
		g2d_box(border_thick, &r, BLACK);
	}
	done(SELECTED);
	vst_alignment(V_handle, 0, 5, &temp, &temp);
}

void icon_characters(ICONBLK *iconblk, short state, short obx, short oby, short icx, short icy)
{
	char lc = iconblk->ib_char;			/* HR: little character */
	short temp,tx,ty,fw,fh,pnt[4];

	vswr_mode(V_handle, MD_REPLACE);
	ritopxy(pnt,obx + iconblk->tx.x, oby + iconblk->tx.y, iconblk->tx.w, iconblk->tx.h);
	vst_font(V_handle, display.small_font_id);
	vst_point(V_handle, display.small_font_point, &temp, &temp, &fw, &fh);

	/* center the text in a bar given by iconblk->tx, relative to object */
	vst_color(V_handle,BLACK);
	if (iconblk->ib_ptext && *iconblk->ib_ptext)
	{
		vsf_color(V_handle,state ? BLACK : WHITE);
		vsf_interior(V_handle,FIS_SOLID);
		v_bar(V_handle,pnt);
	
		tx = obx + iconblk->tx.x + ((iconblk->tx.w - strlen(iconblk->ib_ptext)*6) / 2);	
		ty = oby + iconblk->tx.y + ((iconblk->tx.h - 6) / 2);
		if (state)
			vswr_mode(V_handle, MD_XOR);
		v_gtext(V_handle, tx, ty, iconblk->ib_ptext);
	}
	if (lc != 0 && lc != ' ')			/* HR: something completely forgotten ? */
	{
		char ch[2];
		ch[0] = lc;
		ch[1] = 0;
		v_gtext(V_handle, icx + iconblk->ib_xchar, icy + iconblk->ib_ychar, ch);
		/* Seemingly the ch is supposed to be relative to the image */
	}
	if (state)
		vsf_color(V_handle, WHITE);
	vst_font(V_handle, display.standard_font_id);
	vst_point(V_handle, display.standard_font_point, &temp, &temp, &temp, &temp);
	vswr_mode(V_handle,  MD_TRANS);
}

/*
 *	Draw a image
 */
ObjectDisplay d_g_image	/* (ODC_PARM *odc_p) */
{
	OBJECT *ob = odc_p->tree + odc_p->object;
	OBJC_COLORWORD *colourword;
	BITBLK *bitblk;
	MFDB Mscreen;
	MFDB Micon;
	unsigned short zap;
	short coords[8], cols[2], icx, icy;

	bitblk = (BITBLK *)ob_spec(ob);
	colourword = (OBJC_COLORWORD *)&zap;
	zap = (unsigned short)bitblk->bi_color;
	colourword->pattern = 7;
	set_colours(ob, colourword);

	icx = odc_p->r.x;
	icy = odc_p->r.y;

	Mscreen.fd_addr = NULL;
			
	Micon.fd_w = (bitblk->bi_wb&-2) << 3;		/* HR &-2 */
	Micon.fd_h = bitblk->bi_hl;
	Micon.fd_wdwidth = (Micon.fd_w + 15) >> 4;
	Micon.fd_nplanes = 1;
	Micon.fd_stand = 0;
	Micon.fd_addr = bitblk->bi_pdata;

	cols[0] = colourword->fillc;
	cols[1] = 0;

	coords[0] = bitblk->bi_x;
	coords[1] = bitblk->bi_y;
	coords[2] = Micon.fd_w - 1 - coords[0];
	coords[3] = Micon.fd_h - 1 - coords[1];
	coords[4] = icx;
	coords[5] = icy;
	coords[6] = icx + coords[2];
	coords[7] = icy + coords[3];

	vrt_cpyfm(V_handle, MD_TRANS, coords, &Micon, &Mscreen, cols);
}

/*
 *	Draw a mono icon
 */
ObjectDisplay d_g_icon	/* (ODC_PARM *odc_p) */
{
	OBJECT *ob = odc_p->tree + odc_p->object;
	ICONBLK *iconblk;
	MFDB Mscreen;
	MFDB Micon;
	short coords[8], cols[2], obx, oby, icx, icy, msk_col, icn_col;
	
	iconblk = (ICONBLK *)ob_spec(ob);
	obx = odc_p->r.x;
	oby = odc_p->r.y;
	icx = obx + iconblk->ic.x;
	icy = oby + iconblk->ic.y;

	ritopxy(coords,  0,  0,  iconblk->ic.w,iconblk->ic.h);
	ritopxy(coords+4,icx,icy,iconblk->ic.w,iconblk->ic.h);
	Micon.fd_w = iconblk->ic.w;
	Micon.fd_h = iconblk->ic.h;
	Micon.fd_wdwidth = (Micon.fd_w + 15) >> 4;
	Micon.fd_nplanes = 1;
	Micon.fd_stand = 0;
	Mscreen.fd_addr = NULL;
			
	Micon.fd_addr = iconblk->ib_pmask;
	if (ob->ob_state & SELECTED)
	{
		icn_col = ((iconblk->ib_char) >> 8) & 0xf;
		msk_col = ((iconblk->ib_char) >> 12) & 0xf;
	} else
	{
		icn_col = ((iconblk->ib_char) >> 12) & 0xf;
		msk_col = ((iconblk->ib_char) >> 8) & 0xf;
	}
		
	cols[0] = msk_col;
	cols[1] = icn_col;
	vrt_cpyfm(V_handle, MD_TRANS, coords, &Micon, &Mscreen, cols);
			
	Micon.fd_addr = iconblk->ib_pdata;
	cols[0] = icn_col;
	cols[1] = msk_col;
	vrt_cpyfm(V_handle, MD_TRANS, coords, &Micon, &Mscreen, cols);

	icon_characters(iconblk, ob->ob_state & SELECTED, obx, oby, icx, icy);	/* HR: should be the same for color & mono */
	done(SELECTED);
}

/*
 *	Draw a colour icon
 */

ObjectDisplay d_g_cicon	/* (ODC_PARM *odc_p) */
{
	OBJECT *ob = odc_p->tree + odc_p->object;
	ICONBLK *iconblk;
	CICONBLK *ciconblk;
	CICON	*this_cicon;
	CICON	*best_cicon;
	MFDB Mscreen;
	MFDB Micon;
	short coords[8], cols[258], obx, oby, icx, icy, icn_col;

	ciconblk = (CICONBLK *)ob_spec(ob);
	best_cicon = NULL;
	this_cicon = ciconblk->mainlist;
	while(this_cicon)
	{
		if (   (this_cicon->num_planes <= display.planes)
		    &&((!best_cicon) || (this_cicon->num_planes > best_cicon->num_planes))
		    )
			best_cicon = this_cicon;
		this_cicon = this_cicon->next_res;	
	}
			
	if (!best_cicon)			/* No matching icon, so use the mono one instead */
	{
		d_g_icon(odc_p);
		return;
	}
	
	this_cicon = best_cicon;

	iconblk = (ICONBLK *)ob_spec(ob);
	obx = odc_p->r.x;
	oby = odc_p->r.y;
	icx = obx + iconblk->ic.x;
	icy = oby + iconblk->ic.y;
	
	coords[0] = coords[1] = 0;
	coords[2] = iconblk->ic.w - 1;
	coords[3] = iconblk->ic.h - 1;
	coords[4] = icx;
	coords[5] = icy;
	coords[6] = icx + iconblk->ic.w - 1;
	coords[7] = icy + iconblk->ic.h - 1;
			
	Micon.fd_w = iconblk->ic.w;
	Micon.fd_h = iconblk->ic.h;
	Micon.fd_wdwidth = (Micon.fd_w + 15) >> 4;
	Micon.fd_nplanes = 1;
	Micon.fd_stand = 0;
	Mscreen.fd_addr = NULL;
			
	if (ob->ob_state & SELECTED)
		Micon.fd_addr = this_cicon->sel_mask;
	else
		Micon.fd_addr = this_cicon->col_mask;

	if (display.planes > 8)
		cols[0] = 1, cols[1] = 0;
	else
		cols[0] = 0, cols[1] = 1;

	vrt_cpyfm(V_handle, MD_TRANS, coords, &Micon, &Mscreen, cols);

	if (ob->ob_state & SELECTED)
		Micon.fd_addr = this_cicon->sel_data;
	else
		Micon.fd_addr = this_cicon->col_data;

	Micon.fd_nplanes = display.planes;
	
	vro_cpyfm(V_handle, S_OR_D, coords, &Micon, &Mscreen);

	icon_characters(iconblk, ob->ob_state & SELECTED, obx, oby, icx, icy);
	done(SELECTED);
}

/*
 *	Draw a boxtext object
 */

/* HR: Modifications: set_text(...  &gr, &cr, temp_text ...)
 *     cursor alignment in centered text.
 *     Justification now integrated in set_text (v_gtext isolated).
 *     Preparations for positioning cursor in proportional fonts.
 */
ObjectDisplay d_g_fboxtext	/* (ODC_PARM *odc_p) */
{
	RECT r = odc_p->r;
	OBJECT *ob = odc_p->tree + odc_p->object;
	RECT gr,cr;
	short d;
	OBJC_COLORWORD *colourword;
	unsigned short zap;
	short coords[4], selected=ob->ob_state & SELECTED;
	short border_thick = 0;
	char temp_text[200];

	colourword = (OBJC_COLORWORD *)&zap;

	set_text(ob, &gr, &cr, temp_text, colourword, &border_thick, r);

	if (ob->ob_flags & FLD3DANY)
	{
		XA_3D_pushbutton(0, &r, selected, 0, 1);
		if (selected)
		{
			gr.x += PUSH3D_DISTANCE;
			gr.y += PUSH3D_DISTANCE;
		}

#if T3DREP			/*	HR 3D text always transparent */
		vswr_mode(V_handle, colourword->opaque ? MD_REPLACE : MD_TRANS);
#endif
		v_gtext(V_handle, gr.x, gr.y, temp_text);
		done(SELECTED);
	} else
	{
/*		if (colourword->opaque)*/
			gbar(0, &r);
				
		vswr_mode(V_handle, colourword->opaque ? MD_REPLACE : MD_TRANS);
		v_gtext(V_handle, gr.x, gr.y, temp_text);

		if (selected)
		{
			write_selection(&r);
			done(SELECTED);		/* before border */
		}

		if (border_thick)	/* Display a border? */
		{
			vswr_mode(V_handle, MD_REPLACE);
			g2d_box(border_thick, &r, colourword->borderc);
		}
	}

	if (ob->ob_state & IS_EDIT)		/* write cursor */
		write_selection(&cr);

	vst_font(V_handle, display.standard_font_id);
	vst_point(V_handle, display.standard_font_point, &d, &d, &d, &d);
}

/*
 *	Draw a text object
 */

/* HR: Modifications: set_text(...  &gr, &cr ...)
 *     cursor alignment in centered text.
 *     Justification now integrated in set_text (v_gtext isolated).
 *     Preparations for positioning cursor in proportional fonts.
 *     Moved a few calls.
 */
ObjectDisplay d_g_ftext	/* (ODC_PARM *odc_p) */
{
	OBJECT *ob = odc_p->tree + odc_p->object;
	RECT gr,cr;
	short d;
	OBJC_COLORWORD *colourword;
	unsigned short zap;
	short coords[4], border_thick = 0;
	char temp_text[200];

	colourword = (OBJC_COLORWORD *)&zap;
	set_text(ob, &gr, &cr, temp_text, colourword, &border_thick, odc_p->r);

	vswr_mode(V_handle, colourword->opaque ? MD_REPLACE : MD_TRANS);
	v_gtext(V_handle, gr.x, gr.y, temp_text);		/* HR */

	if (ob->ob_state & IS_EDIT)		/* write cursor */
		write_selection(&cr);

	vst_font(V_handle, display.standard_font_id);
	vst_point(V_handle, display.standard_font_point, &d, &d, &d, &d);
}

/*
 *	Draw a plain hollow ibox
 */
ObjectDisplay d_g_ibox	/* (ODC_PARM *odc_p) */
{
	OBJECT *ob = odc_p->tree + odc_p->object;
	OBJC_COLORWORD *colourword;
	unsigned short zap;
	short border_thick = thickness(ob);
	if (border_thick)	/* Display anything? */
	{
		RECT r = odc_p->r;
		colourword = (OBJC_COLORWORD *)&zap;
		zap = (unsigned short)ob_spec(ob) & 0xffff;
		shadow_object(ob->ob_state, &r, colourword, border_thick);
		set_colours(ob, colourword);
		g2d_box(border_thick, &r, colourword->borderc);
	}
}

#if FIX_PC
int call_pdef(void *, PARMBLK *);	/* saves registerized local variables */
#endif
#ifdef LATTICE
int call_pdef(int (*__stdargs)(PARMBLK *), PARMBLK *);
#pragma inline d0 = call_pdef(a1,) {register d2, a2; "4e91";}
#endif
#ifdef __GNUC__	/* Not needed, it seems (not sure it was correct anyway...) */
#define call_pdef(code,ptr,s)	({ __asm__ volatile (" move.l %2,a7@-; jsr %1@; addql #4,a7; move.l d0,%0" : "&=d"((long)s) : "a"((char *)code), "a"((char *)ptr), "0"((long)s) : "d0", "d1", "d2","a0", "a1", "a2"); })
#endif

ObjectDisplay d_g_progdef	/* (ODC_PARM *odc_p) */
{
	OBJECT *ob = odc_p->tree + odc_p->object;
	APPLBLK *ab;
	PARMBLK p;
	void *old_ssp;
	short smd;

	if (superprogdef)			/* HR */
		smd = (short)Super((void *)1L);
	
	ab = (APPLBLK *)ob_spec(ob);
	p.pb_tree = odc_p->tree;
	p.pb_obj = odc_p->object;

	p.pb_prevstate = p.pb_currstate = ob->ob_state;
				
	p.r = odc_p->r;
				
	p.c.x = global_clip[0];
	p.c.y = global_clip[1];
	p.c.w = global_clip[2] - global_clip[0] + 1;
	p.c.h = global_clip[3] - global_clip[1] + 1;
	
	p.pb_parm = ab->ab_parm;

		/* ++cg[25/2/97]: We run PROGDEF's in supervisor mode because
		   Lattice C 5.52's progdef-in-menu type submenus will cause
		   a privilege violation if we don't */

		/* HR: I made this a configurable option.
		*/

vswr_mode(V_handle,MD_REPLACE);
	if (superprogdef)			/* HR */
		if (!smd)
			old_ssp = (void *)Super((void *)NULL);		/* Enter Supervisor mode*/
		
		/* The PROGDEF function returns the ob_state bits that
			remain to be handled by the AES: */

#ifdef __GNUC__
	*odc_p->state_mask = (short)(*(ab->ab_code))(&p);
#else
	*odc_p->state_mask = (short)call_pdef(ab->ab_code, &p);
#endif

		/* BUG: SELECTED bit only handled in non-color mode!!! */
		/* (Not too serious I believe... <mk>) */
		/* HR: Yes I would call that correct, cause in color mode
			selected appearance is object specific.
			I even think that it shpuldnt be done at ALL.
		*/
/*	if (!MONO)
*/		done(SELECTED);

	if (superprogdef)			/* HR */
		if (!smd)
			Super(old_ssp);			/* Back to User Mode */
}

#if 1
void l_text(short x, short y, char *t, short w, short left)
{
	char ct[256];
	short l = strlen(t);
	w /= display.c_max_w;
	if (left < l)
	{
		strcpy(ct, t + left);
		ct[w]=0;
		v_gtext(V_handle, x, y, ct);
	}
}

void display_list_element(SCROLL_ENTRY *this, short left, short x, short y, short w, short sel)
{
	short xt = x + ICON_W;

	if (this)
	{
		vsf_color(V_handle, sel ? BLACK : WHITE);
		bar(0, xt, y, w - ICON_W, display.c_max_h);
		if (sel)
		{
			vst_color(V_handle, WHITE);
			l_text(xt, y, this->text, w - ICON_W, left);
			vst_color(V_handle, BLACK);
		} else
			l_text(xt, y, this->text, w - ICON_W, left);
	
		vsf_color(V_handle, WHITE);
		bar(0, x, y, ICON_W, display.c_max_h);

		if (this->icon)
		{
			if (sel)
				this->icon->ob_state |= SELECTED;
			else
				this->icon->ob_state &= ~SELECTED;
			display_object(this->icon, 0, x, y);
		}
	} else		/* filler line */
	{
		vsf_color(V_handle, WHITE);
		bar(0, x, y, w, display.c_max_h);
	}
}

ObjectDisplay d_g_slist	/* (ODC_PARM *odc_p) */
{
	RECT r;
	SCROLL_INFO *list;
	SCROLL_ENTRY *this;
	XA_WINDOW *w;
	short y, maxy;
	OBJECT *ob = odc_p->tree + odc_p->object;

	list = (SCROLL_INFO *)ob_spec(ob);
	w = list->wi;

	w->r.x = odc_p->r.x;
	w->r.y = odc_p->r.y;
	calc_work_area(w);		/* for after moving */

	r = w->wa;
	y = r.y;
	maxy = r.y + r.h - display.c_max_h;
	this = list->top;

	if (list->state == 0)
	{
		w->widgets[XAW_TITLE].stuff = list->title;
		if (MONO)
			gbox(2,&odc_p->r);
		else
			br_hook(2,&odc_p->r,display.dial_colours.b_r_col),
			tl_hook(2,&odc_p->r,display.dial_colours.t_l_col);
		display_window(list->lock, w);
		for (; y <= maxy; y += display.c_max_h)
		{
			display_list_element(this, list->left, r.x, y, r.w, this == list->cur);	/* can handle NULL this */
			if (this)
			{
				list->bot = this;
				this = this->next;
			}
		}
	}
	else			/* HR: arrives only here if there are more elements than fit the window */
	{
		RECT fr = r, to;
		fr.h -= display.c_max_h;
		to = fr;
		if (list->state == SCRLSTAT_UP)
		{
			to.y += display.c_max_h;
			form_copy(&fr,&to);
			list->bot = list->bot->prev;
		}
		else if (list->state == SCRLSTAT_DOWN)
		{				
			fr.y += display.c_max_h;
			form_copy(&fr,&to);
			for (; this && y < maxy; this = this->next, y += display.c_max_h);
			list->bot = this;
		}
		display_vslide(list->lock, w, &w->widgets[XAW_VSLIDE]);
		display_list_element(this, list->left, r.x, y, r.w, this == list->cur);
		list->state = 0;
	}
	done(SELECTED);
}
#else
#include "obsolete/d_g_slis.h"
#endif

ObjectDisplay d_g_string	/* (ODC_PARM *odc_p) */
{
	OBJECT *ob = odc_p->tree + odc_p->object;
	char *text = (char *)ob_spec(ob);	/* HR: most AES's allow null string */

	if (text)
	{
		vswr_mode(V_handle, MD_TRANS);
		vst_color(V_handle, BLACK);		/* HR: only 1 color for strings */
		/* HR: only center the text. ;-) */
		v_gtext(V_handle, odc_p->r.x, odc_p->r.y  + ((ob->r.h-display.c_max_h) / 2), text);
	}
}

ObjectDisplay d_g_title	/* (ODC_PARM *odc_p) */
{
	RECT r = odc_p->r;
	OBJECT *ob = odc_p->tree + odc_p->object;
	char *text = (char *)ob_spec(ob);		/* HR: most AES's allow null string */

	if (text)
	{
		vswr_mode(V_handle, MD_TRANS);
		vst_color(V_handle, BLACK);								/* HR */
		v_gtext(V_handle, r.x, r.y + 1, text);	/* HR */
	}

	if (ob->ob_state & SELECTED)
	{
			/* HR: very special!!! */
		r.x += 1, r.y += 1, r.w -= 2, r.h -= 2;
		write_selection(&r);
		done(SELECTED);
	}
}
