/*
 * XaAES - XaAES Ain't the AES
 *
 * A multitasking AES replacement for MiNT
 *
 */

#ifndef _OBJECTS_H_
#define _OBJECTS_H_

void init_objects(void);

/* Externally used routines */
void XA_3D_pushbutton(short d, RECT *r, short state, short flags, short fill);
void display_object(OBJECT *tree, short object, short parent_x, short parent_y);
short draw_object_tree(OBJECT *tree, short object, short depth);
short object_abs_coords(OBJECT *tree, short object, short *obx, short *oby);
short find_object(OBJECT *tree, short object, short depth, short obx, short oby);
void fix_menu(OBJECT *root, bool desk);		/* HR */
short ed_char(TEDINFO *ed_txt, short keycode);
/* HR */
void set_obspec(OBJECT *root, short s_ob, unsigned long cl);
void change_object(OBJECT *root, short i, short start, RECT *r, short state, short draw);

/* Clipping stuff */
void set_clip(const RECT *r);
void clear_clip(void);

/* Internal utility routines */
void set_colours(OBJECT *ob, OBJC_COLORWORD *colourword);
void shadow_object(short state, RECT *r, OBJC_COLORWORD *colourword, short border_thick);
void draw_2d_box(short x, short y, short w, short h, short border_thick, short colour);
void g2d_box(short b, RECT *r, short colour);
void object_area(RECT *c,OBJECT *ob, short i);
void write_menu_line(RECT *cl);
short __stdargs get_parent(OBJECT *ob, short item);
void write_selection(RECT *r);
long calc_back(RECT *r, short planes);

/* HR: intermediate level draw functions & misc. */
void p_gbar(short d, RECT *r);
void p_bar(short d, short x, short y, short w, short h);	/* for perimeter = 1 */
void gbar (short d, RECT *r);
void gbox(short d, RECT *r);
void box  (short d, short x, short y, short w, short h);
void line (short hl, short x, short y, short x1,short y1);
void tl_hook(short d, RECT *r, short col);
void br_hook(short d, RECT *r, short col);
void rtopxy(int *p, const RECT *r);
void ritopxy(int *p, short x, short y, short w, short h);
void *form_save(short d, RECT r, void *area);
void form_restore(short d, RECT r, void *area);
void form_copy(RECT *fr, RECT *to);
char *cramped_name(void *, char *t, short w);
char *clipped_name(void *s, char *t, short w);
short thickness(OBJECT *ob);

char *object_type(OBJECT *tree, short t);

ObjectDisplay
	d_g_box,
	d_g_boxchar,
	d_g_boxtext,
	d_g_button,
	d_g_cicon,
	d_g_fboxtext,
	d_g_ftext,
	d_g_ibox,
	d_g_icon,
	d_g_image,
	d_g_progdef,
	d_g_slist,
	d_g_string,
	d_g_text,
	d_g_title;

#endif
