/*
 * XaAES - XaAES Ain't the AES
 *
 * A multitasking AES replacement for MiNT
 *
 */

/*
	AES OP-Code definitions
*/

#ifndef _XA_CODES_H_
#define _XA_CODES_H_

/* Standard GEM AES op-codes */
typedef enum xa_opcodes
{
	XA_APPL_INIT	= 10,
	XA_APPL_READ,
	XA_APPL_WRITE,
	XA_APPL_FIND,
	XA_APPL_TPLAY,
	XA_APPL_TRECORD,
	XA_APPL_SEARCH	= 18,
	XA_APPL_EXIT,
	XA_APPL_CONTROL = 129,
	XA_APPL_GETINFO,

	XA_EVNT_KEYBD	= 20,
	XA_EVNT_BUTTON,
	XA_EVNT_MOUSE,
	XA_EVNT_MESAG,
	XA_EVNT_TIMER,
	XA_EVNT_MULTI,
	XA_EVNT_DCLICK,

	XA_MENU_BAR		= 30,
	XA_MENU_ICHECK,
	XA_MENU_IENABLE,
	XA_MENU_TNORMAL,
	XA_MENU_TEXT,
	XA_MENU_REGISTER,
	XA_MENU_POPUP,
	XA_MENU_ATTACH,
	XA_MENU_ISTART,
	XA_MENU_SETTINGS,

	XA_OBJC_ADD		= 40,
	XA_OBJC_DELETE,
	XA_OBJC_DRAW,
	XA_OBJC_FIND,
	XA_OBJC_OFFSET,
	XA_OBJC_ORDER,
	XA_OBJC_EDIT,
	XA_OBJC_CHANGE,
	XA_OBJC_SYSVAR,

	XA_FORM_DO		= 50,
	XA_FORM_DIAL,
	XA_FORM_ALERT,
	XA_FORM_ERROR,
	XA_FORM_CENTER,
	XA_FORM_KEYBD,
	XA_FORM_BUTTON,

	XA_GRAF_RUBBERBOX	= 70,
	XA_GRAF_DRAGBOX,
	XA_GRAF_MOVEBOX,
	XA_GRAF_GROWBOX,
	XA_GRAF_SHRINKBOX,
	XA_GRAF_WATCHBOX,
	XA_GRAF_SLIDEBOX,
	XA_GRAF_HANDLE,
	XA_GRAF_MOUSE,
	XA_GRAF_MKSTATE,

	XA_SCRAP_READ	= 80,
	XA_SCRAP_WRITE,

	XA_FSEL_INPUT	= 90,
	XA_FSEL_EXINPUT,

	XA_WIND_CREATE	= 100,
	XA_WIND_OPEN,
	XA_WIND_CLOSE,
	XA_WIND_DELETE,
	XA_WIND_GET,
	XA_WIND_SET,
	XA_WIND_FIND,
	XA_WIND_UPDATE,
	XA_WIND_CALC,
	XA_WIND_NEW,

	XA_RSRC_LOAD	= 110,
	XA_RSRC_FREE,
	XA_RSRC_GADDR,
	XA_RSRC_SADDR,
	XA_RSRC_OBFIX,
	XA_RSRC_RCFIX,

	XA_SHELL_READ	= 120,
	XA_SHELL_WRITE,
	XA_SHELL_GET,
	XA_SHELL_PUT,
	XA_SHELL_FIND,
	XA_SHELL_ENVRN,

/* XaAES specific extended op-codes */
/* (these all start at 250, well out of the way of standard AES calls) */
	XA_BUTTON_CLICK	= 250,
	XA_NEW_CLIENT,
	XA_CLIENT_EXIT,
	XA_SHUTDOWN,

	XA_OBJC_SETSCROLL,

	XA_RREGEN,
	XA_WREDRAW,

	XA_APPL_PIPE	= 260
} XA_opcode;

#endif
